EJ9505 - Power supply plug-in module 5 V DC
Home


Foreword

Foreword
Foreword
Additional information
•
Notes on the documentation
•
Safety instructions
•
Intended use
•
Signal distribution board
•
Documentation issue status
•
Marking of EtherCAT plug-in modules


Notes on the documentation

Foreword [image] Notes on the documentation
Notes on the documentation
Intended audience
This description is only intended for the use of trained specialists in control and automation engineering who are familiar with the applicable national standards.
It is essential that the documentation and the following notes and explanations are followed when installing and commissioning these components.
It is the duty of the technical personnel to use the documentation published at the respective time of each installation and commissioning.
The responsible staff must ensure that the application or use of the products described satisfy all the requirements for safety, including all the relevant laws, regulations, guidelines and standards.
Disclaimer
The documentation has been prepared with care. The products described are, however, constantly under development.
We reserve the right to revise and change the documentation at any time and without prior announcement.
No claims for the modification of products that have already been supplied may be made on the basis of the data, diagrams and descriptions in this documentation.
Trademarks
Beckhoff®, TwinCAT®, EtherCAT®, EtherCAT G®, EtherCAT G10®, EtherCAT P®, Safety over EtherCAT®, TwinSAFE®, XFC®, XTS® and XPlanar® are registered trademarks of and licensed by Beckhoff Automation GmbH. Other designations used in this publication may be trademarks whose use by third parties for their own purposes could violate the rights of the owners.
Patent Pending
The EtherCAT Technology is covered, including but not limited to the following patent applications and patents: EP1590927, EP1789857, EP1456722, EP2137893, DE102015105702 with corresponding applications or registrations in various other countries.
EtherCAT® is registered trademark and patented technology, licensed by Beckhoff Automation GmbH, Germany.
Copyright
© Beckhoff Automation GmbH & Co. KG, Germany.
The reproduction, distribution and utilization of this document as well as the communication of its contents to others without express authorization are prohibited.
Offenders will be held liable for the payment of damages. All rights reserved in the event of the grant of a patent, utility model or design.


Safety instructions

Foreword [image] Safety instructions
Safety instructions
Safety regulations
Please note the following safety instructions and explanations!
Product-specific safety instructions can be found on following pages or in the areas mounting, wiring, commissioning etc.
Exclusion of liability
All the components are supplied in particular hardware and software configurations appropriate for the application. Modifications to hardware or software configurations other than those described in the documentation are not permitted, and nullify the liability of Beckhoff Automation GmbH & Co. KG.
Personnel qualification
This description is only intended for trained specialists in control, automation and drive engineering who are familiar with the applicable national standards.
Description of instructions
In this documentation the following instructions are used.
These instructions must be read carefully and followed without fail!
SmallWarningYellow DANGER
Serious risk of injury!
Failure to follow this safety instruction directly endangers the life and health of persons.
SmallWarningYellow WARNING
Risk of injury!
Failure to follow this safety instruction endangers the life and health of persons.
SmallWarningYellow CAUTION
Personal injuries!
Failure to follow this safety instruction can lead to injuries to persons.
Note
Damage to environment/equipment or data loss
Failure to follow this instruction can lead to environmental damage, equipment damage or data loss.
Tip or pointer
This symbol indicates information that contributes to better understanding.


Intended use

Foreword [image] Intended use
Intended use
SmallWarningYellow WARNING
Caution - Risk of injury!
EJ components may only be used for the purposes described below!


Signal distribution board

Foreword [image] Signal distribution board
Signal distribution board
Note
Signal distribution board
Make sure that the EtherCAT plug-in modules are used only on a signal distribution board that has been developed and manufactured in accordance with the Design Guide.


Documentation issue status

Foreword [image] Documentation issue status
Documentation issue status
Version
Comment
1.1
▪
Note Signal distribution board added
▪
Chapter Version identification of EtherCAT devices replaced by chapter Marking of EtherCAT plug-in modules
▪
Update chapter Technical data
▪
Update chapter Pinout
1.0
First publication EJ9505


Marking of EtherCAT plug-in modules

Foreword [image] Marking of EtherCAT plug-in modules
Marking of EtherCAT plug-in modules
Designation
A Beckhoff EtherCAT device has a 14-digit technical designation, made up as follows (e.g. EJ1008-0000-0017)
▪
Order identifier
–
family key: EJ
–
product designation: The first digit of product designation is used for assignment to a product group (e.g. EJ2xxx = digital output module).
–
Version number: The four digit version number identifies different product variants.
▪
Revision number:
It is incremented when changes are made to the product.
The Order identifier and the revision number are printed on the side of EtherCAT plug-in modules (s. following illustration (A and B).
Order identifier (A), Revision number (B) and serial number (C) using the example of EJ1008
Product group | Example
 | Product designation | Version | Revision
EtherCAT Coupler EJ11xx | EJ1101 | -0022 (Coupler with external connectors, power supply module and optional ID switches | -0016
Digital input modules EJ1xxx | EJ1008 8-channel | -0000 (basic type) | -0017
Digital output modules EJ2xxx | EJ2521 1-channel | -0224 (2 x 24 V outputs) | -0016
Analog input modules EJ3xxx | EJ3318 8-channel thermocouple | -0000 (basic type) | -0017
Analog output modules EJ4xxx | EJ4134 4-channel | -0000 (basic type) | -0019
Special function modules EJ5xxx, EJ6xxx | EJ6224 IO-Link master | -0090 (with TwinSAFE SC) | -0016
Motion modules EJ7xxx | EJ7211 servomotor | -9414 (with ECT, STO and TwinSAFE SC) | -0029
Notes
▪
The elements mentioned above result in the technical designation. EJ1008-0000-0017 is used in the example below.
▪
EJ1008-0000 is the order identifier, in the case of “-0000” usually abbreviated to EJ1008.
▪
The revision -0017 shows the technical progress, such as the extension of features with regard to the EtherCAT communication, and is managed by Beckhoff.
In principle, a device with a higher revision can replace a device with a lower revision, unless specified otherwise, e.g. in the documentation.
Associated and synonymous with each revision there is usually a description (ESI, EtherCAT Slave Information) in the form of an XML file, which is available for download from the Beckhoff web site.
▪
The product designation, version and revision are read as decimal numbers, even if they are technically saved in hexadecimal.
Serial number
The serial number for EtherCAT plug-in modules is usually the 8-digit number printed on the side of the module (see following illustration C). The serial number indicates the configuration in delivery state and therefore refers to a whole production batch, without distinguishing the individual modules of a batch.
Order identifier (A), revision number (B) and serial number (C) using the example of EJ1008
Serial number | Example serial number: 08 15 08 16
KK - week of production (CW, calendar week) | 08 - week of production: 08
YY - year of production | 15 - year of production: 2015
FF - firmware version | 08 -f irmware version: 08
HH - hardware version | 16 - hardware version: 16
Additional information
•
Beckhoff Identification Code (BIC)
•
Certificates


Beckhoff Identification Code (BIC)

Foreword [image] Marking of EtherCAT plug-in modules [image] Beckhoff Identification Code (BIC)
Beckhoff Identification Code (BIC)
The Beckhoff Identification Code (BIC) is increasingly being applied to Beckhoff products to uniquely identify the product. The BIC is represented as a Data Matrix Code (DMC, code scheme ECC200), the content is based on the ANSI standard MH10.8.2-2016.
BIC as data matrix code (DMC, code scheme ECC200)
The BIC will be introduced step by step across all product groups.
Depending on the product, it can be found in the following places:
▪
on the packaging unit
▪
directly on the product (if space suffices)
▪
on the packaging unit and the product
The BIC is machine-readable and contains information that can also be used by the customer for handling and product management.
Each piece of information can be uniquely identified using the so-called data identifier (ANSI MH10.8.2-2016). The data identifier is followed by a character string. Both together have a maximum length according to the table below. If the information is shorter, it shall be replaced by spaces. The data under positions 1-4 are always available.
The following information is contained:
Item no. | Type of information | Explanation | Data identifier | Number of digits incl. data identifier | Example
1 | Beckhoff order number | Beckhoff order number | 1P | 8 | 1P072222
2 | Beckhoff Traceability Number (BTN) | Unique serial number, see note below | S | 12 | SBTNk4p562d7
3 | Article description | Beckhoff article description, e.g. EL1008 | 1K | 32 | 1KEL1809
4 | Quantity | Quantity in packaging unit, e.g. 1, 10, etc. | Q | 6 | Q1
5 | Batch number | Optional: Year and week of production | 2P | 14 | 2P401503180016
6 | ID/serial number | Optional: Present-day serial number system, e.g. with safety products | 51S | 12 | 51S678294104
7 | Variant number | Optional: Product variant number on the basis of standard products | 30P | 32 | 30PF971 , 2*K183
... |  |  |  |  |
Further types of information and data identifiers are used by Beckhoff and serve internal processes.
Structure of the BIC
Example of composite information from items 1 - 4 and 6. The data identifiers are marked in red for better display:
BTN
An important component of the BIC is the Beckhoff Traceability Number (BTN, item no. 2). The BTN is a unique serial number consisting of eight characters that will replace all other serial number systems at Beckhoff in the long term (e.g. batch designations on IO components, previous serial number range for safety products, etc.). The BTN will also be introduced step by step, so it may happen that the BTN is not yet coded in the BIC
Notice
This information has been carefully prepared. However, the procedure described is constantly being further developed. We reserve the right to revise and change procedures and documentation at any time and without prior notice. No claims for changes can be made from the information, illustrations and descriptions in this information.


Certificates

Foreword [image] Marking of EtherCAT plug-in modules [image] Certificates
Certificates
▪
The EhterCAT plug-in modules meet the requirements of the EMC and Low Voltage Directive. The CE mark is printed on the side of the modules.
▪
The cRUus imprint identifies devices that meet product safety requirements according to U.S. and Canadian regulations.
▪
The warning symbol is a request to read the corresponding documentation. The documentations for EtherCAT plug-in modules can be downloaded from the Beckhoff homepage.
Marking for CE and UL using EJ1008 as an example


System overview

System overview
System overview
Electronically, the EJxxxx EtherCAT plug-in modules are based on the EtherCAT I/O system. The EJ system consists of the signal distribution board and EtherCAT plug-in modules. It is also possible to connect an IPC to the EJ system.
The EJ system is suitable for mass production applications, applications with small footprint and applications requiring a low total weight.
The machine complexity can be extended by means of the following:
▪
reserve slots,
▪
the use of placeholder modules,
▪
linking of EtherCAT Terminals and EtherCAT Boxes via an EtherCAT connection.
The following diagram illustrates an EJ system. The components shown are schematic, to illustrate the functionality.
EJ system sample
Signal distribution board
The signal distribution board distributes the signals and the power supply to individual application-specific plug connectors, in order to connect the controller to further machine modules. Using pre-assembled cable harnesses avoids the need for time-consuming connection of individual wires. Coded components reduce the unit costs and the risk of miswiring.
Beckhoff offers development of signal distribution boards as an engineering service. Customers have the option to develop their own signal distribution board, based on the design guide.
EtherCAT plug-in modules
Similar to the EtherCAT terminal system, a module strand consists of a Bus Coupler and I/O modules. Almost all of the EtherCAT Terminals can also be manufactured in the EJ design as EtherCAT plug-in modules. The EJ modules are directly attached to the signal distribution board. The communication, signal distribution and supply take place via the contact pins at the rear of the modules and the PCB tracks of the signal distribution board. The coding pins at the rear serve as mechanical protection against incorrect connection. Color coding on the housing facilitates distinguishing of the modules.


Product overview

Product overview
Product overview
Additional information
•
EJ9505 - Introduction
•
EJ9505 - Technical data
•
EJ9505 - Pinout
•
EJ9505 - LEDs


EJ9505 - Introduction

Product overview [image] EJ9505 - Introduction
EJ9505 - Introduction
EJ9505
Power supply plug-in module 5 VDC
The EJ9505 power supply module generates an output voltage of 5 VDC from the (24 VDC) input voltage. This output voltage can be used to supply power to EtherCAT plug-in modules or external sensors. The input voltage and the output voltage are not electrically isolated.
The power LEDs indicate the module's operating state; the error LED indicates short circuit or overcurrent.


EJ9505 - Technical data

Product overview [image] EJ9505 - Technical data
EJ9505 - Technical data
Technical data | EJ9505
Short-circuit-proof | yes
Input voltage | 24 VDC (-15 % / +20 %)
Input current | 0.2 A (0.24 A / 0.19 A)
Output voltage | 5 VDC ± 1%
Max. output current | 0.5 A
Current consumption via E-bus | typ. 70 mA
Electrical isolation | -
Diagnostics in the process image | yes
permissible ambient temperature range during operation | 0°C .. + 55°C
permissible ambient temperature range during storage | -25°C .. + 85°C
permissible relative humidity | 95 %, no condensation
Operating altitude | max. 2,000 m
Dimensions (W x H x D) | approx. 24 mm x 66 mm x 55 mm
Weight | approx. 50 g
Mounting | on signal distribution board
Pollution degree | 2
Installation position | Standard
Position of the coding pins | 6 and 7
Color coding | grey
Vibration/shock resistance | conforms to EN 60068-2-6 / EN 60068-2-27 (with corresponding signal distribution board)
EMC immunity/emission | conforms to EN 61000-6-2/EN 61000-6-4 (with corresponding signal distribution board)
Protection class | EJ module: IP20, EJ system: dependent on signal distribution board and housing
Approval | CE, UL
Deviation for the output power supply voltage
High external electrical interferences can lead to a short-term deviation of the output power supply voltage of up to 3%.
CE approval
The CE Marking refers to the EtherCAT plug-in module mentioned above.
If the EtherCAT plug-in module is used in the production of a ready-to-use end product (PCB in conjunction with a housing), the manufacturer of the end product must check compliance of the overall system with relevant directives and CE certification.
To operate the EtherCAT plug-in modules, they must be installed in a housing.


EJ9505 - Pinout

Product overview [image] EJ9505 - Pinout
EJ9505 - Pinout
EJ9505 - Pinout
The PCB footprint can be downloaded from the Beckhoff homepage.
Note
Damage to devices possible!
•
The pins named with "NC" must not be connected.
•
Before installation and commissioning read the chapters Installation of EJ modules and Commissioning!


EJ9505 - LEDs

Product overview [image] EJ9505 - LEDs
EJ9505 - LEDs
EJ9505 - LEDs
LEDs (right prism)
LED | Color | Display | State | Meaning
RUN | green | off | Init | State of the EtherCAT State Machine: INIT = Initialization of the terminal or BOOTSTRAP = Function for firmware updates of the terminal
 |  | blinking | Pre-Operational | State of the EtherCAT State Machine: PREOP = Setting for mailbox communication and variant standard settings
 |  | single flash | Safe- Operational | State of the EtherCAT State Machine: SAFEOP = Channel checking of the Sync Manager and the Distributed Clocks. Outputs stay in safe operation mode.
 |  | on | Operational | State of the EtherCAT State Machine: OP = Normal operation mode, mailbox- and process data communication possible
 |  | flickering | Bootstrap | State of the EtherCAT State Machine: BOOTSTRAP = function for firmware updates of the plug-in module
Up | green | off | - | No 24 VDC power supply connected
 |  | on | - | 24 VDC power supply connected
Power | green | off | - | No output voltage (5 VDC) connected
 |  | on | - | Output voltage (5 VDC) connected
Err | red | off | - | No error
 |  | on | - | Short circuit or wire breakage


Installation of EJ modules

Installation of EJ modules
Installation of EJ modules
Additional information
•
Power supply for the EtherCAT plug-in modules
•
EJxxxx - dimensions
•
Installation positions and minimum distances
•
Codings
•
Installation on the signal distribution board
•
Extension options
•
IPC integration
•
Disassembly of the signal distribution board


Power supply for the EtherCAT plug-in modules

Installation of EJ modules [image] Power supply for the EtherCAT plug-in modules
Power supply for the EtherCAT plug-in modules
SmallWarningYellow WARNING
Power supply
A SELV/PELV power supply must be used to supply power for the EJ coupler and modules. Couplers and modules have to be connected to SELV/PELV circuits exclusively.
The signal distribution board should have a power supply designed for the maximum possible current load of the module string. Information on the current required from the E-bus supply can be found for each module in the respective documentation in section “Technical data“, online and in the catalog. The power requirement of the module string is displayed in the TwinCAT System Manager (see Current consumption of the EJ modules from the E-bus).
E-bus power supply with EJ1100 or EJ1101-0022 and EJ940x
The EJ1100 Bus Coupler supplies the connected EJ modules with the E-bus system voltage of 3.3 V. The Coupler can accommodate a load up to 2.2 A. If a higher current is required, a combination of the coupler EJ1101-0022 and the power supply units EJ9400 (2.5 A) or EJ9404 (12 A) should be used. The EJ940x power supply units can be used as additional supply modules in the module string.
Depending on the application, the following combinations for the E-bus supply are available:
E-bus power supply with EJ1100 or EJ1101-0022 + EJ940x
In the EJ1101-0022 coupler, the RJ45 connectors and optional ID switches are external and can be positioned anywhere on the signal distribution board, as required. This facilitates feeding through a housing.
The EJ940x power supply plug-in modules provide an optional reset function (see chapter Connection of the documentation for EJ9400 and EJ9404)
E-bus power supply with CXxxxx and EK1110-0043
The Embedded PC supplies the attached EtherCAT Terminals and the EtherCAT EJ Coupler
▪
with a supply voltage of 24 VDC (-15 %/+20%). This voltage supplies the E-bus and the Bus Terminal electronics.
The CXxxxx units supply the E-bus with up to 2,000 mA E-bus current. If a higher current is required due to the attached terminals, power feed terminals or power supply plug-in modules must be used for the E-bus supply.
▪
with a peripheral voltage Up of 24 VDC to supply the field electronics.
The EK1110-0043 EtherCAT EJ Coupler relays the following parameters to the signal distribution board via the rear connector:
▪
the E-bus signals,
▪
the E-bus voltage UEBUS (3.3 V) and
▪
the peripheral voltage UP (24 VDC).
PCB with Embedded PC, EK1110-0043 and EJxxxx, rear view EK1110-0043


EJxxxx - dimensions

Installation of EJ modules [image] EJxxxx - dimensions
EJxxxx - dimensions
The EJ modules are compact and lightweight thanks to their design. Their volume is approx. 50% smaller than the volume of the EL terminals. A distinction is made between four different module types, depending on the width and the height:
Module type | Dimensions (W x H x D) | Sample in figure below
Coupler | 44 mm x 66 mm x 55 mm | EJ1100 (ej_44_2xrj45_coupler)
Single module | 12 mm x 66 mm x 55 mm | EJ1809 (ej_12_16pin_code13)
Double module | 24 mm x 66 mm x 55 mm | EJ7342 (ej_24_2x16pin_code18)
Single module (long) | 12 mm x 152 mm x 55 mm | EJ1957 (ej_12_2x16pin_extended_code4747)
EJxxxx - Dimensions
The technical drawings can be downloaded from the download finder. The drawings are named as described in the drawing below.
Technical drawings from download finder


Installation positions and minimum distances

Installation of EJ modules [image] Installation positions and minimum distances
Installation positions and minimum distances
Additional information
•
Minimum distances for ensuring installability
•
Installation positions


Minimum distances for ensuring installability

Installation of EJ modules [image] Installation positions and minimum distances [image] Minimum distances for ensuring installability
Minimum distances for ensuring installability
Note the dimensions shown in the following diagram for the design of the signal distribution board to ensure safe latching and simple assembly / disassembly of the modules.
Mounting distances EJ module - PCB
Observing the reaching area
A minimum reaching area of 92 mm is required for assembly / disassembly, in order to be able to reach the mounting tabs with the fingers.
Adherence to the recommended minimum distances for ventilation (see section Installation position) ensures an adequate reaching area.
The signal distribution board must have a thickness of 1.6 mm and a minimum distance of 4 mm from the mounting surface, in order to ensure latching of the modules on the board.


Installation positions

Installation of EJ modules [image] Installation positions and minimum distances [image] Installation positions
Installation positions
Note
Constraints regarding installation position and operating temperature range
Please refer to the technical data for the installed components to ascertain whether any restrictions regarding the mounting position and/or the operating temperature range have been specified. During installation of modules with increased thermal dissipation, ensure adequate distance above and below the modules to other components in order to ensure adequate ventilation of the modules during operation!
The standard installation position is recommended. If a different installation position is used, check whether additional ventilation measures are required.
Ensure that the specified conditions (see Technical data) are adhered to!
Optimum installation position (standard)
For the optimum installation position the signal distribution board is installed horizontally, and the fronts of the EJ modules face forward (see Fig. Recommended distances for standard installation position). The modules are ventilated from below, which enables optimum cooling of the electronics through convection. "From below" is relative to the acceleration of gravity.
Recommended distances for standard installation position
Compliance with the distances shown in Fig. Recommended distances for standard installation position” is recommend. The recommended minimum distances should not be regarded as restricted areas for other components. The customer is responsible for verifying compliance with the environmental conditions described in the technical data. Additional cooling measures must be provided, if required.
Other installation positions
All other installation positions are characterized by a different spatial position of the signal distribution board, see Fig. “Other installation positions”.
The minimum distances to ambient specified above also apply to these installation positions.
EJxxx_other mounting positions
Other installation positions


Codings

Installation of EJ modules [image] Codings
Codings
Additional information
•
Color coding
•
Mechanical position coding


Color coding

Installation of EJ modules [image] Codings [image] Color coding
Color coding
EJ modules color code; sample: EJ1809
The EJ modules are color-coded for a better overview in the control cabinet (see diagram above). The color code indicates the signal type. The following table provides an overview of the signal types with corresponding color coding.
Signal type | Modules | Color
Coupler | EJ11xx | No color coding
Digital input | EJ1xxx | Yellow
Digital output | EJ2xxx | Red
Analog input | EJ3xxx | Green
Analog output | EJ4xxx | Blue
Motion | EJ7xxx | orange
System | EJ9xxx | grey


Mechanical position coding

Installation of EJ modules [image] Codings [image] Mechanical position coding
Mechanical position coding
The modules have two signal-specific coding pins on the underside (see Figs. B1 and B2 below). In conjunction with the coding holes in the signal distribution board (see Figs. A1 and A2 below), the coding pins provide an option for mechanical protection against incorrect connection. This significantly reduces the risk of error during installation and service.
Couplers and placeholder modules have no coding pins.
Mechanical position coding with coding pins (B1 and B2) and coding holes (A1 and A2)
The following diagram shows the position of the position coding with position numbers on the left-hand side. Modules with the same signal type have the same coding. For sample, all digital input modules have the coding pins at positions one and three. There is no plug protection between modules with the same signal type. During installation the module type should therefore be verified based on the device name.
Pin coding; sample: digital input modules


Installation on the signal distribution board

Installation of EJ modules [image] Installation on the signal distribution board
Installation on the signal distribution board
EJ modules are installed on the signal distribution board. The electrical connections between coupler and EJ modules are realized via the pin contacts and the signal distribution board.
The EJ components must be installed in a control cabinet or enclosure which must provide protection against fire hazards, environmental conditions and mechanical impact.
SmallWarningYellow WARNING
Risk of injury through electric shock and damage to the device!
Bring the module system into a safe, de-energized state before starting installation, disassembly or wiring of the modules.
Note
Risk of damage to components through electrostatic discharge!
Observe the regulations for ESD protection.
Installation of EJ modules
A1 / A2 | Latching lugs top / bottom | C1 / C2 | Mounting holes
B1 / B2 | Coding pins | D1 / D2 | Coding holes
To install the modules on the signal distribution board proceed as follows:
1.
Before the installation, ensure that the signal distribution board is securely connected to the mounting surface. Installation on an unsecured signal distribution board may result in damage to the board.
2.
If necessary, check whether the positions of the coding pins (B) match the corresponding holes in the signal distribution board (D).
3.
Compare the device name on the module with the information in the installation drawing.
4.
Press the upper and the lower mounting tabs simultaneously and push the module onto the board while gently moving it up and down, until the module is latched securely.
The required contact pressure can only be established and the maximum current carrying capacity ensured if the module is latched securely.
5.
Use placeholder modules (EJ9001) to fill gaps in the module strand.
Note
•
During installation ensure safe latching of the modules on the signal distribution board! The consequences of inadequate contact pressure include:
⇨
loss of quality of the transferred signals,
⇨
increased power dissipation of the contacts,
⇨
impairment of the service life.


Extension options

Installation of EJ modules [image] Extension options
Extension options
Three options are available for modifications and extensions of the EJ system.
▪
Replacing the placeholder modules with the function modules provided for the respective slot
▪
Assigning function modules specified for the respective slots for the reserve slots at the end of the module string
▪
Linking with EtherCAT Terminals and EtherCAT Box modules via an Ethernet/EtherCAT connection
Additional information
•
Using placeholder modules for unused slots
•
Linking with EtherCAT Terminals and EtherCAT Box modules via an Ethernet/EtherCAT connection


Using placeholder modules for unused slots

Installation of EJ modules [image] Extension options [image] Using placeholder modules for unused slots
Using placeholder modules for unused slots
The EJ9001 placeholder modules are used to close temporary gaps in the module strands (see Fig. A1 below). In contrast to the passive terminals of the EL series, the placeholder modules actively participate in the data exchange. Several placeholder modules can therefore be connected in series, without impairing the data exchange.
Unused slots at the end of the module strand can be left as reserve slots (see Fig. B1 below).
The machine complexity is extended (extended version) by allocating unused slots (see Figs. A2 below - Exchanging placeholder modules and B2 - Assigning reserve slots) according to the specifications for the signal distribution board.
Sample: Exchanging placeholder modules and assigning reserve slots
E-bus supply
Exchange the placeholder modules with other modules changes the current input from the E-Bus. Ensure that adequate power supply is provided.


Linking with EtherCAT Terminals and EtherCAT Box modules via an Ethernet/EtherCAT connection

Installation of EJ modules [image] Extension options [image] Linking with EtherCAT Terminals and EtherCAT Box modules via an Ethernet/EtherCAT connection
Linking with EtherCAT Terminals and EtherCAT Box modules via an Ethernet/EtherCAT connection
Example of extension via an Ethernet/EtherCAT connection


IPC integration

Installation of EJ modules [image] IPC integration
IPC integration
Connection of CX and EL terminals via the EK1110-0043 EtherCAT EJ Coupler
The EK1110-0043 EtherCAT EJ Coupler connects the compact DIN-rail PCs of the CX series and attached EtherCAT Terminals (ELxxxx) with the EJ modules on the signal distribution board.
The EK1110-0043 is supplied from the power supply unit of the Embedded PC.
The E-bus signals and the supply voltage of the field side UP are routed directly to the PCB via a plug connector at the rear of the EtherCAT EJ Coupler.
Due to the direct coupling of the Embedded PC and the EL terminals with the EJ modules on the PCB, no EtherCAT extension (EK1110) or EtherCAT Coupler (EJ1100) is required.
The Embedded PC can be expanded with EtherCAT Terminals that are not yet available in the EJ system, for example.
Example PCB with Embedded PC, EK1110-0043 and EJxxxx, rear view EK1110-0043
Connection of C6015 / C6017 via the EJ110x-00xx EtherCAT Coupler
Thanks to their ultra-compact design and versatile mounting options, the C6015 and C6017 IPCs are ideally suited for connection to an EJ system.
In combination with the ZS5000-0003 mounting set, it is possible to place the C6015 and C6017 IPCs compactly on the signal distribution board.
The EJ system is optimally connected to the IPC via the corresponding EtherCAT cable (see following Fig. [A]).
The IPC can be supplied directly via the signal distribution board using the enclosed power plug (see Fig. [B] below).
Note
Positioning on the signal distribution board
The dimensions and distances for placement and other details can be found in the Design Guide and the documentation for the individual components.
The figure below shows the connection of a C6015 IPC to an EJ system as an example. The components shown are schematic, to illustrate the functionality.
Example for the connection of a C6015 IPC to an EJ system


Disassembly of the signal distribution board

Installation of EJ modules [image] Disassembly of the signal distribution board
Disassembly of the signal distribution board
SmallWarningYellow WARNING
Risk of injury through electric shock and damage to the device!
Bring the module system into a safe, de-energized state before starting installation, disassembly or wiring of the modules.
Note
Risk of damage to components through electrostatic discharge!
Observe the regulations for ESD protection.
Each module is secured through latching on the distribution board, which has to be released for disassembly.
Disassembly of EJ modules
To disassemble the module from the signal distribution board proceed as follows:
1.
Before disassembly, ensure that the signal distribution board is securely connected to the mounting surface. Disassembly of an unsecured signal distribution board may result in damage to the board.
2.
Press the upper and lower mounting tabs simultaneously and pull the module from board while gently moving it up and down.


Basics communication

Basics communication
Basics communication
Additional information
•
EtherCAT basics
•
EtherCAT devices - cabling - wired
•
General notes for setting the watchdog
•
EtherCAT State Machine
•
CoE Interface
•
Distributed Clock


EtherCAT basics

Basics communication [image] EtherCAT basics
EtherCAT basics
Please refer to the EtherCAT System Documentation for the EtherCAT fieldbus basics.


EtherCAT devices - cabling - wired

Basics communication [image] EtherCAT devices - cabling - wired
EtherCAT devices - cabling - wired
The cable length between two EtherCAT devices must not exceed 100 m. This results from the FastEthernet technology, which, above all for reasons of signal attenuation over the length of the cable, allows a maximum link length of 5 + 90 + 5 m if cables with appropriate properties are used. See also the Design recommendations for the infrastructure for EtherCAT/Ethernet.
Cables and connectors
For connecting EtherCAT devices only Ethernet connections (cables + plugs) that meet the requirements of at least category 5 (CAt5) according to EN 50173 or ISO/IEC 11801 should be used. EtherCAT uses 4 wires for signal transfer.
EtherCAT uses RJ45 plug connectors, for example. The pin assignment is compatible with the Ethernet standard (ISO/IEC 8802-3).
Pin | Color of conductor | Signal | Description
1 | yellow | TD + | Transmission Data +
2 | orange | TD - | Transmission Data -
3 | white | RD + | Receiver Data +
6 | blue | RD - | Receiver Data -
Due to automatic cable detection (auto-crossing) symmetric (1:1) or cross-over cables can be used between EtherCAT devices from Beckhoff.
Recommended cables
Suitable cables for the connection of EtherCAT devices can be found on the Beckhoff website!


General notes for setting the watchdog

Basics communication [image] General notes for setting the watchdog
General notes for setting the watchdog
ELxxxx terminals are equipped with a safety feature (watchdog) that switches off the outputs after a specifiable time e.g. in the event of an interruption of the process data traffic, depending on the device and settings, e.g. in OFF state.
The EtherCAT slave controller (ESC) in the EL2xxx terminals features 2 watchdogs:
▪
SM watchdog (default: 100 ms)
▪
PDI watchdog (default: 100 ms)
SM watchdog (SyncManager Watchdog)
The SyncManager watchdog is reset after each successful EtherCAT process data communication with the terminal. If no EtherCAT process data communication takes place with the terminal for longer than the set and activated SM watchdog time, e.g. in the event of a line interruption, the watchdog is triggered and the outputs are set to FALSE. The OP state of the terminal is unaffected. The watchdog is only reset after a successful EtherCAT process data access. Set the monitoring time as described below.
The SyncManager watchdog monitors correct and timely process data communication with the ESC from the EtherCAT side.
PDI watchdog (Process Data Watchdog)
If no PDI communication with the EtherCAT slave controller (ESC) takes place for longer than the set and activated PDI watchdog time, this watchdog is triggered.
PDI (Process Data Interface) is the internal interface between the ESC and local processors in the EtherCAT slave, for example. The PDI watchdog can be used to monitor this communication for failure.
The PDI watchdog monitors correct and timely process data communication with the ESC from the application side.
The settings of the SM- and PDI-watchdog must be done for each slave separately in the TwinCAT System Manager.
EtherCAT tab -> Advanced Settings -> Behavior -> Watchdog
Notes:
▪
the multiplier is valid for both watchdogs.
▪
each watchdog has its own timer setting, the outcome of this in summary with the multiplier is a resulting time.
▪
Important: the multiplier/timer setting is only loaded into the slave at the start up, if the checkbox is activated.
If the checkbox is not activated, nothing is downloaded and the ESC settings remain unchanged.
Multiplier
Multiplier
Both watchdogs receive their pulses from the local terminal cycle, divided by the watchdog multiplier:
1/25 MHz * (watchdog multiplier + 2) = 100 µs (for default setting of 2498 for the multiplier)
The standard setting of 1000 for the SM watchdog corresponds to a release time of 100 ms.
The value in multiplier + 2 corresponds to the number of basic 40 ns ticks representing a watchdog tick.
The multiplier can be modified in order to adjust the watchdog time over a larger range.
Example "Set SM watchdog"
This checkbox enables manual setting of the watchdog times. If the outputs are set and the EtherCAT communication is interrupted, the SM watchdog is triggered after the set time and the outputs are erased. This setting can be used for adapting a terminal to a slower EtherCAT master or long cycle times. The default SM watchdog setting is 100 ms. The setting range is 0..65535. Together with a multiplier with a range of 1..65535 this covers a watchdog period between 0..~170 seconds.
Calculation
Multiplier = 2498 → watchdog base time = 1 / 25 MHz * (2498 + 2) = 0.0001 seconds = 100 µs
SM watchdog = 10000 → 10000 * 100 µs = 1 second watchdog monitoring time
SmallWarningYellow CAUTION
Undefined state possible!
The function for switching off of the SM watchdog via SM watchdog = 0 is only implemented in terminals from version -0016. In previous versions this operating mode should not be used.
SmallWarningYellow CAUTION
Damage of devices and undefined state possible!
If the SM watchdog is activated and a value of 0 is entered the watchdog switches off completely. This is the deactivation of the watchdog! Set outputs are NOT set in a safe state, if the communication is interrupted.


EtherCAT State Machine

Basics communication [image] EtherCAT State Machine
EtherCAT State Machine
The state of the EtherCAT slave is controlled via the EtherCAT State Machine (ESM). Depending upon the state, different functions are accessible or executable in the EtherCAT slave. Specific commands must be sent by the EtherCAT master to the device in each state, particularly during the bootup of the slave.
A distinction is made between the following states:
▪
Init
▪
Pre-Operational
▪
Safe-Operational and
▪
Operational
▪
Boot
The regular state of each EtherCAT slave after bootup is the OP state.
States of the EtherCAT State Machine
Init
After switch-on the EtherCAT slave in the Init state. No mailbox or process data communication is possible. The EtherCAT master initializes sync manager channels 0 and 1 for mailbox communication.
Pre-Operational (Pre-Op)
During the transition between Init and Pre-Op the EtherCAT slave checks whether the mailbox was initialized correctly.
In Pre-Op state mailbox communication is possible, but not process data communication. The EtherCAT master initializes the sync manager channels for process data (from sync manager channel 2), the FMMU channels and, if the slave supports configurable mapping, PDO mapping or the sync manager PDO assignment. In this state the settings for the process data transfer and perhaps terminal-specific parameters that may differ from the default settings are also transferred.
Safe-Operational (Safe-Op)
During transition between Pre-Op and Safe-Op the EtherCAT slave checks whether the sync manager channels for process data communication and, if required, the distributed clocks settings are correct. Before it acknowledges the change of state, the EtherCAT slave copies current input data into the associated DP-RAM areas of the EtherCAT slave controller (ECSC).
In Safe-Op state mailbox and process data communication is possible, although the slave keeps its outputs in a safe state, while the input data are updated cyclically.
Outputs in SAFEOP state
The default set watchdog monitoring sets the outputs of the module in a safe state - depending on the settings in SAFEOP and OP - e.g. in OFF state. If this is prevented by deactivation of the watchdog monitoring in the module, the outputs can be switched or set also in the SAFEOP state.
Operational (Op)
Before the EtherCAT master switches the EtherCAT slave from Safe-Op to Op it must transfer valid output data.
In the Op state the slave copies the output data of the masters to its outputs. Process data and mailbox communication is possible.
Boot
In the Boot state the slave firmware can be updated. The Boot state can only be reached via the Init state.
In the Boot state mailbox communication via the file access over EtherCAT (FoE) protocol is possible, but no other mailbox communication and no process data communication.


CoE Interface

Basics communication [image] CoE Interface
CoE Interface
General description
The CoE interface (CANopen over EtherCAT) is used for parameter management of EtherCAT devices. EtherCAT slaves or the EtherCAT master manage fixed (read only) or variable parameters which they require for operation, diagnostics or commissioning.
CoE parameters are arranged in a table hierarchy. In principle, the user has read access via the fieldbus. The EtherCAT master (TwinCAT System Manager) can access the local CoE lists of the slaves via EtherCAT in read or write mode, depending on the attributes.
Different CoE parameter types are possible, including string (text), integer numbers, Boolean values or larger byte fields. They can be used to describe a wide range of features. Examples of such parameters include manufacturer ID, serial number, process data settings, device name, calibration values for analog measurement or passwords.
The order is specified in 2 levels via hexadecimal numbering: (main)index, followed by subindex. The value ranges are
▪
Index: 0x0000 …0xFFFF (0...65535dez)
▪
SubIndex: 0x00…0xFF (0...255dez)
A parameter localized in this way is normally written as 0x8010:07, with preceding "x" to identify the hexadecimal numerical range and a colon between index and subindex.
The relevant ranges for EtherCAT fieldbus users are:
▪
0x1000: This is where fixed identity information for the device is stored, including name, manufacturer, serial number etc., plus information about the current and available process data configurations.
▪
0x8000: This is where the operational and functional parameters for all channels are stored, such as filter settings or output frequency.
Other important ranges are:
▪
0x4000: In some EtherCAT devices the channel parameters are stored here (as an alternative to the 0x8000 range).
▪
0x6000: Input PDOs ("input" from the perspective of the EtherCAT master)
▪
0x7000: Output PDOs ("output" from the perspective of the EtherCAT master)
Availability
Not every EtherCAT device must have a CoE list. Simple I/O modules without dedicated processor usually have no variable parameters and therefore no CoE list.
If a device has a CoE list, it is shown in the TwinCAT System Manager as a separate tab with a listing of the elements:
"CoE Online " tab
The figure above shows the CoE objects available in device "EL2502", ranging from 0x1000 to 0x1600. The subindices for 0x1018 are expanded.
Data management and function "NoCoeStorage"
Some parameters, particularly the setting parameters of the slave, are configurable and writeable. This can be done in write or read mode
▪
via the System Manager (Fig. "CoE Online " tab) by clicking
This is useful for commissioning of the system/slaves. Click on the row of the index to be parameterised and enter a value in the "SetValue" dialog.
▪
from the control system/PLC via ADS, e.g. through blocks from the TcEtherCAT.lib library
This is recommended for modifications while the system is running or if no System Manager or operating staff are available.
Data management
If slave CoE parameters are modified online, Beckhoff devices store any changes in a fail-safe manner in the EEPROM, i.e. the modified CoE parameters are still available after a restart.
The situation may be different with other manufacturers.

An EEPROM is subject to a limited lifetime with respect to write operations. From typically 100,000 write operations onwards it can no longer be guaranteed that new (changed) data are reliably saved or are still readable. This is irrelevant for normal commissioning. However, if CoE parameters are continuously changed via ADS at machine runtime, it is quite possible for the lifetime limit to be reached. Support for the NoCoeStorage function, which suppresses the saving of changed CoE values, depends on the firmware version.
Please refer to the technical data in this documentation as to whether this applies to the respective device.
•
If the function is supported: the function is activated by entering the code word 0x12345678 once in CoE 0xF008 and remains active as long as the code word is not changed. After switching the device on it is then inactive. Changed CoE values are not saved in the EEPROM and can thus be changed any number of times.
•
Function is not supported: continuous changing of CoE values is not permissible in view of the lifetime limit.
Startup list
Changes in the local CoE list of the terminal are lost if the terminal is replaced. If a terminal is replaced with a new Beckhoff terminal, it will have the default settings. It is therefore advisable to link all changes in the CoE list of an EtherCAT slave with the Startup list of the slave, which is processed whenever the EtherCAT fieldbus is started. In this way a replacement EtherCAT slave can automatically be parameterized with the specifications of the user.
If EtherCAT slaves are used which are unable to store local CoE values permanently, the Startup list must be used.
Recommended approach for manual modification of CoE parameters
▪
Make the required change in the System Manager
The values are stored locally in the EtherCAT slave
▪
If the value is to be stored permanently, enter it in the Startup list.
The order of the Startup entries is usually irrelevant.
Startup list in the TwinCAT System Manager
The Startup list may already contain values that were configured by the System Manager based on the ESI specifications. Additional application-specific entries can be created.
Online/offline list
While working with the TwinCAT System Manager, a distinction has to be made whether the EtherCAT device is "available", i.e. switched on and linked via EtherCAT and therefore online, or whether a configuration is created offline without connected slaves.
In both cases a CoE list as shown in Fig. “’CoE online’ tab” is displayed. The connectivity is shown as offline/online.
▪
If the slave is offline
–
The offline list from the ESI file is displayed. In this case modifications are not meaningful or possible.
–
The configured status is shown under Identity.
–
No firmware or hardware version is displayed, since these are features of the physical device.
–
Offline is shown in red.
Offline list
▪
If the slave is online
–
The actual current slave list is read. This may take several seconds, depending on the size and cycle time.
–
The actual identity is displayed
–
The firmware and hardware version of the equipment according to the electronic information is displayed
–
Online is shown in green.
Online list
Channel-based order
The CoE list is available in EtherCAT devices that usually feature several functionally equivalent channels. For example, a 4-channel analog 0..10 V input terminal also has 4 logical channels and therefore 4 identical sets of parameter data for the channels. In order to avoid having to list each channel in the documentation, the placeholder "n" tends to be used for the individual channel numbers.
In the CoE system 16 indices, each with 255 subindices, are generally sufficient for representing all channel parameters. The channel-based order is therefore arranged in 16dec/10hex steps. The parameter range 0x8000 exemplifies this:
▪
Channel 0: parameter range 0x8000:00 ... 0x800F:255
▪
Channel 1: parameter range 0x8010:00 ... 0x801F:255
▪
Channel 2: parameter range 0x8020:00 ... 0x802F:255
▪
...
This is generally written as 0x80n0.
Detailed information on the CoE interface can be found in the EtherCAT system documentation on the Beckhoff website.


Distributed Clock

Basics communication [image] Distributed Clock
Distributed Clock
The distributed clock represents a local clock in the EtherCAT slave controller (ESC) with the following characteristics:
▪
Unit 1 ns
▪
Zero point 1.1.2000 00:00
▪
Size 64 bit (sufficient for the next 584 years; however, some EtherCAT slaves only offer 32-bit support, i.e. the variable overflows after approx. 4.2 seconds)
▪
The EtherCAT master automatically synchronizes the local clock with the master clock in the EtherCAT bus with a precision of < 100 ns.
For detailed information please refer to the EtherCAT system description.


Commissioning

Commissioning
Commissioning
Additional information
•
TwinCAT Quick Start
•
TwinCAT Development Environment
•
General notes for commissioning of the EtherCAT slave


TwinCAT Quick Start

Commissioning [image] TwinCAT Quick Start
TwinCAT Quick Start
TwinCAT is a development environment for real-time control including multi-PLC system, NC axis control, programming and operation. The whole system is mapped through this environment and enables access to a programming environment (including compilation) for the controller. Individual digital or analog inputs or outputs can also be read or written directly, in order to verify their functionality, for example.
For further information please refer to http://infosys.beckhoff.com:
▪
EtherCAT Systemmanual:
Fieldbus Components → EtherCAT Terminals → EtherCAT System Documentation → Setup in the TwinCAT System Manager
▪
TwinCAT 2 → TwinCAT System Manager → I/O - Configuration
▪
In particular, TwinCAT driver installation:
Fieldbus components → Fieldbus Cards and Switches → FC900x – PCI Cards for Ethernet → Installation
Devices contain the terminals for the actual configuration. All configuration data can be entered directly via editor functions (offline) or via the "Scan" function (online):
▪
"offline": The configuration can be customized by adding and positioning individual components. These can be selected from a directory and configured.
–
The procedure for offline mode can be found under http://infosys.beckhoff.com:
TwinCAT 2 → TwinCAT System Manager → IO - Configuration → Adding an I/O Device
▪
"online": The existing hardware configuration is read
–
See also http://infosys.beckhoff.com:
Fieldbus components → Fieldbus cards and switches → FC900x – PCI Cards for Ethernet → Installation → Searching for devices
The following relationship is envisaged from user PC to the individual control elements:
Relationship between user side (commissioning) and installation
The user inserting of certain components (I/O device, terminal, box...) is the same in TwinCAT 2 and TwinCAT 3. The descriptions below relate to the online procedure.
Sample configuration (actual configuration)
Based on the following sample configuration, the subsequent subsections describe the procedure for TwinCAT 2 and TwinCAT 3:
▪
Control system (PLC) CX2040 including CX2100-0004 power supply unit
▪
Connected to the CX2040 on the right (E-bus):
EL1004 (4-channel digital input terminal 24 V DC)
▪
Linked via the X001 port (RJ-45): EK1100 EtherCAT Coupler
▪
Connected to the EK1100 EtherCAT coupler on the right (E-bus):
EL2008 (8-channel digital output terminal 24 V DC; 0.5 A)
▪
(Optional via X000: a link to an external PC for the user interface)
Control configuration with Embedded PC, input (EL1004) and output (EL2008)
Note that all combinations of a configuration are possible; for example, the EL1004 terminal could also be connected after the coupler, or the EL2008 terminal could additionally be connected to the CX2040 on the right, in which case the EK1100 coupler wouldn’t be necessary.
Additional information
•
TwinCAT 2
•
TwinCAT 3


TwinCAT 2

Commissioning [image] TwinCAT Quick Start [image] TwinCAT 2
TwinCAT 2
Startup
TwinCAT basically uses two user interfaces: the TwinCAT System Manager for communication with the electromechanical components and TwinCAT PLC Control for the development and compilation of a controller. The starting point is the TwinCAT System Manager.
After successful installation of the TwinCAT system on the PC to be used for development, the TwinCAT 2 System Manager displays the following user interface after startup:
Initial TwinCAT 2 user interface
Generally, TwinCAT can be used in local or remote mode. Once the TwinCAT system including the user interface (standard) is installed on the respective PLC, TwinCAT can be used in local mode and thereby the next step is "Insert Device".
If the intention is to address the TwinCAT runtime environment installed on a PLC as development environment remotely from another system, the target system must be made known first. In the menu under "Actions" → "Choose Target System...", via the symbol " [image] " or the "F8" key, open the following window:
Selection of the target system
Use "Search (Ethernet)..." to enter the target system. Thus a next dialog opens to either:
▪
enter the known computer name after "Enter Host Name / IP:" (as shown in red)
▪
perform a "Broadcast Search" (if the exact computer name is not known)
▪
enter the known computer IP or AmsNetID.
Specify the PLC for access by the TwinCAT System Manager: selection of the target system
Once the target system has been entered, it is available for selection as follows (a password may have to be entered):
After confirmation with "OK" the target system can be accessed via the System Manager.
Adding devices
In the configuration tree of the TwinCAT 2 System Manager user interface on the left, select "I/O Devices” and then right-click to open a context menu and select "Scan Devices…", or start the action in the menu bar via [image]. The TwinCAT System Manager may first have to be set to "Config mode" via [image] or via menu
“Actions" → "Set/Reset TwinCAT to Config Mode…" (Shift + F4).
Select "Scan Devices..."
Confirm the warning message, which follows, and select "EtherCAT" in the dialog:
Automatic detection of I/O devices: selection the devices to be integrated
Confirm the message "Find new boxes", in order to determine the terminals connected to the devices. "Free Run" enables manipulation of input and output values in "Config mode" and should also be acknowledged.
Based on the sample configuration described at the beginning of this section, the result is as follows:
Mapping of the configuration in the TwinCAT 2 System Manager
The whole process consists of two stages, which may be performed separately (first determine the devices, then determine the connected elements such as boxes, terminals, etc.). A scan can also be initiated by selecting "Device ..." from the context menu, which then reads the elements present in the configuration below:
Reading of individual terminals connected to a device
This functionality is useful if the actual configuration is modified at short notice.
Programming and integrating the PLC
TwinCAT PLC Control is the development environment for the creation of the controller in different program environments: TwinCAT PLC Control supports all languages described in IEC 61131-3. There are two text-based languages and three graphical languages.
▪
Text-based languages
–
Instruction List (IL)
–
Structured Text (ST)
▪
Graphical languages
–
Function Block Diagram (FBD)
–
Ladder Diagram (LD)
–
The Continuous Function Chart Editor (CFC)
–
Sequential Function Chart (SFC)
The following section refers to Structured Text (ST).
After starting TwinCAT PLC Control, the following user interface is shown for an initial project:
TwinCAT PLC Control after startup
Sample variables and a sample program have been created and stored under the name "PLC_example.pro":
Sample program with variables after a compile process (without variable integration)
Warning 1990 (missing "VAR_CONFIG") after a compile process indicates that the variables defined as external (with the ID "AT%I*" or "AT%Q*") have not been assigned. After successful compilation, TwinCAT PLC Control creates a "*.tpy" file in the directory in which the project was stored. This file (*.tpy) contains variable assignments and is not known to the System Manager, hence the warning. Once the System Manager has been notified, the warning no longer appears.
First, integrate the TwinCAT PLC Control project in the System Manager via the context menu of the PLC configuration; right-click and select "Append PLC Project…":
Appending the TwinCAT PLC Control project
Select the PLC configuration "PLC_example.tpy" in the browser window that opens. The project including the two variables identified with "AT" are then integrated in the configuration tree of the System Manager:
PLC project integrated in the PLC configuration of the System Manager
The two variables "bEL1004_Ch4" and "nEL2008_value" can now be assigned to certain process objects of the I/O configuration.
Assigning variables
Open a window for selecting a suitable process object (PDO) via the context menu of a variable of the integrated project "PLC_example" and via "Modify Link..." "Standard":
Creating the links between PLC variables and process objects
In the window that opens, the process object for the variable “bEL1004_Ch4” of type BOOL can be selected from the PLC configuration tree:
Selecting PDO of type BOOL
According to the default setting, certain PDO objects are now available for selection. In this sample the input of channel 4 of the EL1004 terminal is selected for linking. In contrast, the checkbox "All types" must be ticked for creating the link for the output variables, in order to allocate a set of eight separate output bits to a byte variable. The following diagram shows the whole process:
Selecting several PDOs simultaneously: activate "Continuous" and "All types"
Note that the "Continuous" checkbox was also activated. This is designed to allocate the bits contained in the byte of the variable "nEL2008_value" sequentially to all eight selected output bits of the EL2008 terminal. In this way it is possible to subsequently address all eight outputs of the terminal in the program with a byte corresponding to bit 0 for channel 1 to bit 7 for channel 8 of the PLC. A special symbol ( [image]) at the yellow or red object of the variable indicates that a link exists. The links can also be checked by selecting a "Goto Link Variable” from the context menu of a variable. The object opposite, in this case the PDO, is automatically selected:
Application of a "Goto Link" variable, using "MAIN.bEL1004_Ch4" as a sample
The process of assigning variables to the PDO is completed via the menu selection "Actions" → "Generate Mappings”, key Ctrl+M or by clicking on the symbol [image] in the menu.
This can be visualized in the configuration:
The process of creating links can also take place in the opposite direction, i.e. starting with individual PDOs to variable. However, in this example it would then not be possible to select all output bits for the EL2008, since the terminal only makes individual digital outputs available. If a terminal has a byte, word, integer or similar PDO, it is possible to allocate this a set of bit-standardised variables (type "BOOL"). Here, too, a "Goto Link Variable” from the context menu of a PDO can be executed in the other direction, so that the respective PLC instance can then be selected.
Activation of the configuration
The allocation of PDO to PLC variables has now established the connection from the controller to the inputs and outputs of the terminals. The configuration can now be activated. First, the configuration can be verified via [image] (or via "Actions" → "Check Configuration”). If no error is present, the configuration can be activated via [image] (or via "Actions" → "Activate Configuration…") to transfer the System Manager settings to the runtime system. Confirm the messages "Old configurations are overwritten!" and "Restart TwinCAT system in Run mode" with "OK".
A few seconds later the real-time status [image] is displayed at the bottom right in the System Manager. The PLC system can then be started as described below.
Starting the controller
Starting from a remote system, the PLC control has to be linked with the Embedded PC over Ethernet via "Online" → “Choose Run-Time System…":
Choose target system (remote)
In this sample "Runtime system 1 (port 801)" is selected and confirmed. Link the PLC with the real-time system via menu option "Online" → "Login", the F11 key or by clicking on the symbol [image]. The control program can then be loaded for execution. This results in the message "No program on the controller! Should the new program be loaded?", which should be acknowledged with "Yes". The runtime environment is ready for the program start:
PLC Control logged in, ready for program startup
The PLC can now be started via "Online" → "Run", F5 key or [image].


TwinCAT 3

Commissioning [image] TwinCAT Quick Start [image] TwinCAT 3
TwinCAT 3
Startup
TwinCAT makes the development environment areas available together with Microsoft Visual Studio: after startup, the project folder explorer appears on the left in the general window area (cf. "TwinCAT System Manager" of TwinCAT 2) for communication with the electromechanical components.
After successful installation of the TwinCAT system on the PC to be used for development, TwinCAT 3 (shell) displays the following user interface after startup:
Initial TwinCAT 3 user interface
First create a new project via [image] (or under "File"→“New"→ "Project…"). In the following dialog make the corresponding entries as required (as shown in the diagram):
Create new TwinCAT project
The new project is then available in the project folder explorer:
New TwinCAT3 project in the project folder explorer
Generally, TwinCAT can be used in local or remote mode. Once the TwinCAT system including the user interface (standard) is installed on the respective PLC, TwinCAT can be used in local mode and thereby the next step is "Insert Device".
If the intention is to address the TwinCAT runtime environment installed on a PLC as development environment remotely from another system, the target system must be made known first. Via the symbol in the menu bar:
expand the pull-down menu:
and open the following window:
Selection dialog: Choose the target system
Use "Search (Ethernet)..." to enter the target system. Thus a next dialog opens to either:
▪
enter the known computer name after "Enter Host Name / IP:" (as shown in red)
▪
perform a "Broadcast Search" (if the exact computer name is not known)
▪
enter the known computer IP or AmsNetID.
Specify the PLC for access by the TwinCAT System Manager: selection of the target system
Once the target system has been entered, it is available for selection as follows (a password may have to be entered):
After confirmation with "OK" the target system can be accessed via the Visual Studio shell.
Adding devices
In the project folder explorer of the Visual Studio shell user interface on the left, select "Devices" within element “I/O”, then right-click to open a context menu and select "Scan" or start the action via [image] in the menu bar. The TwinCAT System Manager may first have to be set to "Config mode" via [image] or via the menu "TwinCAT" → "Restart TwinCAT (Config mode)".
Select "Scan"
Confirm the warning message, which follows, and select "EtherCAT" in the dialog:
Automatic detection of I/O devices: selection the devices to be integrated
Confirm the message "Find new boxes", in order to determine the terminals connected to the devices. "Free Run" enables manipulation of input and output values in "Config mode" and should also be acknowledged.
Based on the sample configuration described at the beginning of this section, the result is as follows:
Mapping of the configuration in VS shell of the TwinCAT3 environment
The whole process consists of two stages, which may be performed separately (first determine the devices, then determine the connected elements such as boxes, terminals, etc.). A scan can also be initiated by selecting "Device ..." from the context menu, which then reads the elements present in the configuration below:
Reading of individual terminals connected to a device
This functionality is useful if the actual configuration is modified at short notice.
Programming the PLC
TwinCAT PLC Control is the development environment for the creation of the controller in different program environments: TwinCAT PLC Control supports all languages described in IEC 61131-3. There are two text-based languages and three graphical languages.
▪
Text-based languages
–
Instruction List (IL)
–
Structured Text (ST)
▪
Graphical languages
–
Function Block Diagram (FBD)
–
Ladder Diagram (LD)
–
The Continuous Function Chart Editor (CFC)
–
Sequential Function Chart (SFC)
The following section refers to Structured Text (ST).
In order to create a programming environment, a PLC subproject is added to the project sample via the context menu of "PLC" in the project folder explorer by selecting "Add New Item….":
Adding the programming environment in "PLC"
In the dialog that opens select "Standard PLC project" and enter "PLC_example" as project name, for example, and select a corresponding directory:
Specifying the name and directory for the PLC programming environment
The "Main" program, which already exists by selecting "Standard PLC project", can be opened by double-clicking on "PLC_example_project" in "POUs”. The following user interface is shown for an initial project:
Initial "Main" program of the standard PLC project
To continue, sample variables and a sample program have now been created:
Sample program with variables after a compile process (without variable integration)
The control program is now created as a project folder, followed by the compile process:
Start program compilation
The following variables, identified in the ST/ PLC program with "AT%", are then available in under "Assignments" in the project folder explorer:
Assigning variables
Via the menu of an instance - variables in the "PLC” context, use the "Modify Link…" option to open a window for selecting a suitable process object (PDO) for linking:
Creating the links between PLC variables and process objects
In the window that opens, the process object for the variable "bEL1004_Ch4" of type BOOL can be selected from the PLC configuration tree:
Selecting PDO of type BOOL
According to the default setting, certain PDO objects are now available for selection. In this sample the input of channel 4 of the EL1004 terminal is selected for linking. In contrast, the checkbox "All types" must be ticked for creating the link for the output variables, in order to allocate a set of eight separate output bits to a byte variable. The following diagram shows the whole process:
Selecting several PDOs simultaneously: activate "Continuous" and "All types"
Note that the "Continuous" checkbox was also activated. This is designed to allocate the bits contained in the byte of the variable "nEL2008_value" sequentially to all eight selected output bits of the EL2008 terminal. In this way it is possible to subsequently address all eight outputs of the terminal in the program with a byte corresponding to bit 0 for channel 1 to bit 7 for channel 8 of the PLC. A special symbol ( [image]) at the yellow or red object of the variable indicates that a link exists. The links can also be checked by selecting a "Goto Link Variable” from the context menu of a variable. The object opposite, in this case the PDO, is automatically selected:
Application of a "Goto Link" variable, using "MAIN.bEL1004_Ch4" as a sample
The process of creating links can also take place in the opposite direction, i.e. starting with individual PDOs to variable. However, in this example it would then not be possible to select all output bits for the EL2008, since the terminal only makes individual digital outputs available. If a terminal has a byte, word, integer or similar PDO, it is possible to allocate this a set of bit-standardised variables (type "BOOL"). Here, too, a "Goto Link Variable” from the context menu of a PDO can be executed in the other direction, so that the respective PLC instance can then be selected.
Activation of the configuration
The allocation of PDO to PLC variables has now established the connection from the controller to the inputs and outputs of the terminals. The configuration can now be activated with [image] or via the menu under "TwinCAT" in order to transfer settings of the development environment to the runtime system. Confirm the messages "Old configurations are overwritten!" and "Restart TwinCAT system in Run mode" with "OK". The corresponding assignments can be seen in the project folder explorer:
A few seconds later the corresponding status of the Run mode is displayed in the form of a rotating symbol [image] at the bottom right of the VS shell development environment. The PLC system can then be started as described below.
Starting the controller
Select the menu option "PLC" → "Login" or click on [image] to link the PLC with the real-time system and load the control program for execution. This results in the message "No program on the controller! Should the new program be loaded?", which should be acknowledged with "Yes". The runtime environment is ready for program start by click on symbol [image], the "F5" key or via "PLC" in the menu selecting “Start”. The started programming environment shows the runtime values of individual variables:
TwinCAT development environment (VS shell): logged-in, after program startup
The two operator control elements for stopping [image] and logout [image] result in the required action (accordingly also for stop "Shift + F5", or both actions can be selected via the PLC menu).


TwinCAT Development Environment

Commissioning [image] TwinCAT Development Environment
TwinCAT Development Environment
The Software for automation TwinCAT (The Windows Control and Automation Technology) will be distinguished into:
▪
TwinCAT 2: System Manager (Configuration) & PLC Control (Programming)
▪
TwinCAT 3: Enhancement of TwinCAT 2 (Programming and Configuration takes place via a common Development Environment)
Details:
▪
TwinCAT 2:
–
Connects I/O devices to tasks in a variable-oriented manner
–
Connects tasks to tasks in a variable-oriented manner
–
Supports units at the bit level
–
Supports synchronous or asynchronous relationships
–
Exchange of consistent data areas and process images
–
Datalink on NT - Programs by open Microsoft Standards (OLE, OCX, ActiveX, DCOM+, etc.)
–
Integration of IEC 61131-3-Software-SPS, Software- NC and Software-CNC within Windows NT/2000/XP/Vista, Windows 7, NT/XP Embedded, CE
–
Interconnection to all common fieldbusses
–
More…
Additional features:
▪
TwinCAT 3 (eXtended Automation):
–
Visual-Studio®-Integration
–
Choice of the programming language
–
Supports object orientated extension of IEC 61131-3
–
Usage of C/C++ as programming language for real time applications
–
Connection to MATLAB®/Simulink®
–
Open interface for expandability
–
Flexible run-time environment
–
Active support of Multi-Core- und 64-Bit-Operatingsystem
–
Automatic code generation and project creation with the TwinCAT Automation Interface
–
More…
Within the following sections commissioning of the TwinCAT Development Environment on a PC System for the control and also the basically functions of unique control elements will be explained.
Please see further information to TwinCAT 2 and TwinCAT 3 at http://infosys.beckhoff.com.
Additional information
•
Installation of the TwinCAT real-time driver
•
Notes regarding ESI device description
•
TwinCAT ESI Updater
•
Distinction between Online and Offline
•
OFFLINE configuration creation
•
ONLINE configuration creation
•
EtherCAT subscriber configuration


Installation of the TwinCAT real-time driver

Commissioning [image] TwinCAT Development Environment [image] Installation of the TwinCAT real-time driver
Installation of the TwinCAT real-time driver
In order to assign real-time capability to a standard Ethernet port of an IPC controller, the Beckhoff real-time driver has to be installed on this port under Windows.
This can be done in several ways. One option is described here.
In the System Manager call up the TwinCAT overview of the local network interfaces via Options → Show Real Time Ethernet Compatible Devices.
System Manager “Options” (TwinCAT 2)
This have to be called up by the Menü “TwinCAT” within the TwinCAT 3 environment:
Call up under VS Shell (TwinCAT 3)
The following dialog appears:
Overview of network interfaces
Interfaces listed under “Compatible devices” can be assigned a driver via the “Install” button. A driver should only be installed on compatible devices.
A Windows warning regarding the unsigned driver can be ignored.
Alternatively an EtherCAT-device can be inserted first of all as described in chapter Offline configuration creation, section “Creating the EtherCAT device” in order to view the compatible ethernet ports via its EtherCAT properties (tab „Adapter“, button „Compatible Devices…“):
EtherCAT device properties(TwinCAT 2): click on „Compatible Devices…“ of tab “Adapter”
TwinCAT 3: the properties of the EtherCAT device can be opened by double click on “Device .. (EtherCAT)” within the Solution Explorer under “I/O”:
After the installation the driver appears activated in the Windows overview for the network interface (Windows Start → System Properties → Network)
Windows properties of the network interface
A correct setting of the driver could be:
Exemplary correct driver setting for the Ethernet port
Other possible settings have to be avoided:
Incorrect driver settings for the Ethernet port
IP address of the port used
IP address/DHCP
In most cases an Ethernet port that is configured as an EtherCAT device will not transport general IP packets. For this reason and in cases where an EL6601 or similar devices are used it is useful to specify a fixed IP address for this port via the “Internet Protocol TCP/IP” driver setting and to disable DHCP. In this way the delay associated with the DHCP client for the Ethernet port assigning itself a default IP address in the absence of a DHCP server is avoided. A suitable address space is 192.168.x.x, for example.
TCP/IP setting for the Ethernet port


Notes regarding ESI device description

Commissioning [image] TwinCAT Development Environment [image] Notes regarding ESI device description
Notes regarding ESI device description
Installation of the latest ESI device description
The TwinCAT EtherCAT master/System Manager needs the device description files for the devices to be used in order to generate the configuration in online or offline mode. The device descriptions are contained in the so-called ESI files (EtherCAT Slave Information) in XML format. These files can be requested from the respective manufacturer and are made available for download. An *.xml file may contain several device descriptions.
The ESI files for Beckhoff EtherCAT devices are available on the Beckhoff website.
The ESI files should be stored in the TwinCAT installation directory.
Default settings:
▪
TwinCAT 2: C:\TwinCAT\IO\EtherCAT
▪
TwinCAT 3: C:\TwinCAT\3.1\Config\Io\EtherCAT
The files are read (once) when a new System Manager window is opened, if they have changed since the last time the System Manager window was opened.
A TwinCAT installation includes the set of Beckhoff ESI files that was current at the time when the TwinCAT build was created.
For TwinCAT 2.11/TwinCAT 3 and higher, the ESI directory can be updated from the System Manager, if the programming PC is connected to the Internet; by
▪
TwinCAT 2: Option → “Update EtherCAT Device Descriptions”
▪
TwinCAT 3: TwinCAT → EtherCAT Devices → “Update Device Descriptions (via ETG Website)…”
The TwinCAT ESI Updater is available for this purpose.
ESI
The *.xml files are associated with *.xsd files, which describe the structure of the ESI XML files. To update the ESI device descriptions, both file types should therefore be updated.
Device differentiation
EtherCAT devices/slaves are distinguished by four properties, which determine the full device identifier. For example, the device identifier EL2521-0025-1018 consists of:
▪
family key “EL”
▪
name “2521”
▪
type “0025”
▪
and revision “1018”
Identifier structure
The order identifier consisting of name + type (here: EL2521-0010) describes the device function. The revision indicates the technical progress and is managed by Beckhoff. In principle, a device with a higher revision can replace a device with a lower revision, unless specified otherwise, e.g. in the documentation. Each revision has its own ESI description. See further notes.
Online description
If the EtherCAT configuration is created online through scanning of real devices (see section Online setup) and no ESI descriptions are available for a slave (specified by name and revision) that was found, the System Manager asks whether the description stored in the device should be used. In any case, the System Manager needs this information for setting up the cyclic and acyclic communication with the slave correctly.
OnlineDescription information window (TwinCAT 2)
In TwinCAT 3 a similar window appears, which also offers the Web update:
Information window OnlineDescription (TwinCAT 3)
If possible, the Yes is to be rejected and the required ESI is to be requested from the device manufacturer. After installation of the XML/XSD file the configuration process should be repeated.
Note
Changing the ‘usual’ configuration through a scan
✓
If a scan discovers a device that is not yet known to TwinCAT, distinction has to be made between two cases. Taking the example here of the EL2521-0000 in the revision 1019
1.
no ESI is present for the EL2521-0000 device at all, either for the revision 1019 or for an older revision. The ESI must then be requested from the manufacturer (in this case Beckhoff).
2.
an ESI is present for the EL2521-0000 device, but only in an older revision, e.g. 1018 or 1017.
In this case an in-house check should first be performed to determine whether the spare parts stock allows the integration of the increased revision into the configuration at all. A new/higher revision usually also brings along new features. If these are not to be used, work can continue without reservations with the previous revision 1018 in the configuration. This is also stated by the Beckhoff compatibility rule.
Refer in particular to the chapter ‘General notes on the use of Beckhoff EtherCAT IO components’ and for manual configuration to the chapter ‘Offline configuration creation’.
If the OnlineDescription is used regardless, the System Manager reads a copy of the device description from the EEPROM in the EtherCAT slave. In complex slaves the size of the EEPROM may not be sufficient for the complete ESI, in which case the ESI would be incomplete in the configurator. Therefore it’s recommended using an offline ESI file with priority in such a case.
The System Manager creates for online recorded device descriptions a new file “OnlineDescription0000...xml” in its ESI directory, which contains all ESI descriptions that were read online.
File OnlineDescription.xml created by the System Manager
Is a slave desired to be added manually to the configuration at a later stage, online created slaves are indicated by a prepended symbol “>” in the selection list (see Figure “Indication of an online recorded ESI of EL2521 as an example”).
Indication of an online recorded ESI of EL2521 as an example
If such ESI files are used and the manufacturer's files become available later, the file OnlineDescription.xml should be deleted as follows:
▪
close all System Manager windows
▪
restart TwinCAT in Config mode
▪
delete "OnlineDescription0000...xml"
▪
restart TwinCAT System Manager
This file should not be visible after this procedure, if necessary press <F5> to update
OnlineDescription for TwinCAT 3.x
In addition to the file described above "OnlineDescription0000...xml" , a so called EtherCAT cache with new discovered devices is created by TwinCAT 3.x, e.g. under Windows 7:

(Please note the language settings of the OS!)
You have to delete this file, too.
Faulty ESI file
If an ESI file is faulty and the System Manager is unable to read it, the System Manager brings up an information window.
Information window for faulty ESI file (left: TwinCAT 2; right: TwinCAT 3)
Reasons may include:
▪
Structure of the *.xml does not correspond to the associated *.xsd file → check your schematics
▪
Contents cannot be translated into a device description → contact the file manufacturer


TwinCAT ESI Updater

Commissioning [image] TwinCAT Development Environment [image] TwinCAT ESI Updater
TwinCAT ESI Updater
For TwinCAT 2.11 and higher, the System Manager can search for current Beckhoff ESI files automatically, if an online connection is available:
Using the ESI Updater (>= TwinCAT 2.11)
The call up takes place under:
“Options” → "Update EtherCAT Device Descriptions"
Selection under TwinCAT 3:
Using the ESI Updater (TwinCAT 3)
The ESI Updater (TwinCAT 3) is a convenient option for automatic downloading of ESI data provided by EtherCAT manufacturers via the Internet into the TwinCAT directory (ESI = EtherCAT slave information). TwinCAT accesses the central ESI ULR directory list stored at ETG; the entries can then be viewed in the Updater dialog, although they cannot be changed there.
The call up takes place under:
“TwinCAT“ → „EtherCAT Devices“ → “Update Device Description (via ETG Website)…“.


Distinction between Online and Offline

Commissioning [image] TwinCAT Development Environment [image] Distinction between Online and Offline
Distinction between Online and Offline
The distinction between online and offline refers to the presence of the actual I/O environment (drives, terminals, EJ-modules). If the configuration is to be prepared in advance of the system configuration as a programming system, e.g. on a laptop, this is only possible in “Offline configuration” mode. In this case all components have to be entered manually in the configuration, e.g. based on the electrical design.
If the designed control system is already connected to the EtherCAT system and all components are energised and the infrastructure is ready for operation, the TwinCAT configuration can simply be generated through “scanning” from the runtime system. This is referred to as online configuration.
In any case, during each startup the EtherCAT master checks whether the slaves it finds match the configuration. This test can be parameterised in the extended slave settings. Refer to note “Installation of the latest ESI-XML device description”.
For preparation of a configuration:
▪
the real EtherCAT hardware (devices, couplers, drives) must be present and installed
▪
the devices/modules must be connected via EtherCAT cables or in the terminal/ module strand in the same way as they are intended to be used later
▪
the devices/modules be connected to the power supply and ready for communication
▪
TwinCAT must be in CONFIG mode on the target system.
The online scan process consists of:
▪
detecting the EtherCAT device (Ethernet port at the IPC)
▪
detecting the connected EtherCAT devices. This step can be carried out independent of the preceding step
▪
troubleshooting
The scan with existing configuration can also be carried out for comparison.


OFFLINE configuration creation

Commissioning [image] TwinCAT Development Environment [image] OFFLINE configuration creation
OFFLINE configuration creation
Creating the EtherCAT device
Create an EtherCAT device in an empty System Manager window.
Append EtherCAT device (left: TwinCAT 2; right: TwinCAT 3)
Select type ‘EtherCAT’ for an EtherCAT I/O application with EtherCAT slaves. For the present publisher/subscriber service in combination with an EL6601/EL6614 terminal select “EtherCAT Automation Protocol via EL6601”.
Selecting the EtherCAT connection (TwinCAT 2.11, TwinCAT 3)
Then assign a real Ethernet port to this virtual device in the runtime system.
Selecting the Ethernet port
This query may appear automatically when the EtherCAT device is created, or the assignment can be set/modified later in the properties dialog; see Fig. “EtherCAT device properties (TwinCAT 2)”.
EtherCAT device properties (TwinCAT 2)
TwinCAT 3: the properties of the EtherCAT device can be opened by double click on “Device .. (EtherCAT)” within the Solution Explorer under “I/O”:
Selecting the Ethernet port
Ethernet ports can only be selected for EtherCAT devices for which the TwinCAT real-time driver is installed. This has to be done separately for each port. Please refer to the respective installation page.
Defining EtherCAT slaves
Further devices can be appended by right-clicking on a device in the configuration tree.
Appending EtherCAT devices (left: TwinCAT 2; right: TwinCAT 3)
The dialog for selecting a new device opens. Only devices for which ESI files are available are displayed.
Only devices are offered for selection that can be appended to the previously selected device. Therefore the physical layer available for this port is also displayed (Fig. “Selection dialog for new EtherCAT device”, A). In the case of cable-based Fast-Ethernet physical layer with PHY transfer, then also only cable-based devices are available, as shown in Fig. “Selection dialog for new EtherCAT device”. If the preceding device has several free ports (e.g. EK1122 or EK1100), the required port can be selected on the right-hand side (A).
Overview of physical layer
▪
“Ethernet”: cable-based 100BASE-TX: EK couplers, EP boxes, devices with RJ45/M8/M12 connector
▪
“E-Bus”: LVDS “terminal bus”, “EJ-module”: EL/ES terminals, various modular modules
The search field facilitates finding specific devices (since TwinCAT 2.11 or TwinCAT 3).
Selection dialog for new EtherCAT device
By default only the name/device type is used as selection criterion. For selecting a specific revision of the device the revision can be displayed as “Extended Information”.
Display of device revision
In many cases several device revisions were created for historic or functional reasons, e.g. through technological advancement. For simplification purposes (see Fig. “Selection dialog for new EtherCAT device”) only the last (i.e. highest) revision and therefore the latest state of production is displayed in the selection dialog for Beckhoff devices. To show all device revisions available in the system as ESI descriptions tick the “Show Hidden Devices” check box, see Fig. “Display of previous revisions”.
Display of previous revisions
Device selection based on revision, compatibility
The ESI description also defines the process image, the communication type between master and slave/device and the device functions, if applicable. The physical device (firmware, if available) has to support the communication queries/settings of the master. This is backward compatible, i.e. newer devices (higher revision) should be supported if the EtherCAT master addresses them as an older revision. The following compatibility rule of thumb is to be assumed for Beckhoff EtherCAT Terminals/ Boxes/ EJ-modules:
device revision in the system >= device revision in the configuration
This also enables subsequent replacement of devices without changing the configuration (different specifications are possible for drives).
Example:
If an EL2521-0025-1018 is specified in the configuration, an EL2521-0025-1018 or higher (-1019, -1020) can be used in practice.
Name/revision of the terminal
If current ESI descriptions are available in the TwinCAT system, the last revision offered in the selection dialog matches the Beckhoff state of production. It is recommended to use the last device revision when creating a new configuration, if current Beckhoff devices are used in the real application. Older revisions should only be used if older devices from stock are to be used in the application.
In this case the process image of the device is shown in the configuration tree and can be parameterised as follows: linking with the task, CoE/DC settings, plug-in definition, startup settings, ...
EtherCAT terminal in the TwinCAT tree (left: TwinCAT 2; right: TwinCAT 3)


ONLINE configuration creation

Commissioning [image] TwinCAT Development Environment [image] ONLINE configuration creation
ONLINE configuration creation
Detecting/scanning of the EtherCAT device
The online device search can be used if the TwinCAT system is in CONFIG mode. This can be indicated by a symbol right below in the information bar:
▪
on TwinCAT 2 by a blue display “Config Mode” within the System Manager window: .
▪
on TwinCAT 3 within the user interface of the development environment by a symbol [image].
TwinCAT can be set into this mode:
▪
TwinCAT 2: by selection of [image] in the Menubar or by “Actions” → “Set/Reset TwinCAT to Config Mode…”
▪
TwinCAT 3: by selection of [image] in the Menubar or by „TwinCAT“ → “Restart TwinCAT (Config Mode)“
Online scanning in Config mode
The online search is not available in RUN mode (production operation). Note the differentiation between TwinCAT programming system and TwinCAT target system.
The TwinCAT 2 icon ( [image]) or TwinCAT 3 icon ( [image]) within the Windows-Taskbar always shows the TwinCAT mode of the local IPC. Compared to that, the System Manager window of TwinCAT 2 or the user interface of TwinCAT 3 indicates the state of the target system.
Differentiation local/target system (left: TwinCAT 2; right: TwinCAT 3)
Right-clicking on “I/O Devices” in the configuration tree opens the search dialog.
Scan Devices (left: TwinCAT 2; right: TwinCAT 3)
This scan mode attempts to find not only EtherCAT devices (or Ethernet ports that are usable as such), but also NOVRAM, fieldbus cards, SMB etc. However, not all devices can be found automatically.
Note for automatic device scan (left: TwinCAT 2; right: TwinCAT 3)
Ethernet ports with installed TwinCAT real-time driver are shown as “RT Ethernet” devices. An EtherCAT frame is sent to these ports for testing purposes. If the scan agent detects from the response that an EtherCAT slave is connected, the port is immediately shown as an “EtherCAT Device” .
Detected Ethernet devices
Via respective checkboxes devices can be selected (as illustrated in Fig. “Detected Ethernet devices” e.g. Device 3 and Device 4 were chosen). After confirmation with “OK” a device scan is suggested for all selected devices, see Fig.: “Scan query after automatic creation of an EtherCAT device”.
Selecting the Ethernet port
Ethernet ports can only be selected for EtherCAT devices for which the TwinCAT real-time driver is installed. This has to be done separately for each port. Please refer to the respective installation page.
Detecting/Scanning the EtherCAT devices
Online scan functionality
During a scan the master queries the identity information of the EtherCAT slaves from the slave EEPROM. The name and revision are used for determining the type. The respective devices are located in the stored ESI data and integrated in the configuration tree in the default state defined there.
Example default state
Note
Slave scanning in practice in series machine production
The scanning function should be used with care. It is a practical and fast tool for creating an initial configuration as a basis for commissioning. In series machine production or reproduction of the plant, however, the function should no longer be used for the creation of the configuration, but if necessary for comparison with the defined initial configuration.Background: since Beckhoff occasionally increases the revision version of the delivered products for product maintenance reasons, a configuration can be created by such a scan which (with an identical machine construction) is identical according to the device list; however, the respective device revision may differ from the initial configuration.
Example:
Company A builds the prototype of a machine B, which is to be produced in series later on. To do this the prototype is built, a scan of the IO devices is performed in TwinCAT and the initial configuration ‘B.tsm’ is created. The EL2521-0025 EtherCAT terminal with the revision 1018 is located somewhere. It is thus built into the TwinCAT configuration in this way:
Installing EthetCAT terminal with revision -1018
Likewise, during the prototype test phase, the functions and properties of this terminal are tested by the programmers/commissioning engineers and used if necessary, i.e. addressed from the PLC ‘B.pro’ or the NC. (the same applies correspondingly to the TwinCAT 3 solution files).
The prototype development is now completed and series production of machine B starts, for which Beckhoff continues to supply the EL2521-0025-0018. If the commissioning engineers of the series machine production department always carry out a scan, a B configuration with the identical contents results again for each machine. Likewise, A might create spare parts stores worldwide for the coming series-produced machines with EL2521-0025-1018 terminals.
After some time Beckhoff extends the EL2521-0025 by a new feature C. Therefore the FW is changed, outwardly recognizable by a higher FW version and a new revision -1019. Nevertheless the new device naturally supports functions and interfaces of the predecessor version(s); an adaptation of ‘B.tsm’ or even ‘B.pro’ is therefore unnecessary. The series-produced machines can continue to be built with ‘B.tsm’ and ‘B.pro’; it makes sense to perform a comparative scan against the initial configuration ‘B.tsm’ in order to check the built machine.
However, if the series machine production department now doesn’t use ‘B.tsm’, but instead carries out a scan to create the productive configuration, the revision -1019 is automatically detected and built into the configuration:
Detection of EtherCAT terminal with revision -1019
This is usually not noticed by the commissioning engineers. TwinCAT cannot signal anything either, since virtually a new configuration is created. According to the compatibility rule, however, this means that no EL2521-0025-1018 should be built into this machine as a spare part (even if this nevertheless works in the vast majority of cases).
In addition, it could be the case that, due to the development accompanying production in company A, the new feature C of the EL2521-0025-1019 (for example, an improved analog filter or an additional process data for the diagnosis) is discovered and used without in-house consultation. The previous stock of spare part devices are then no longer to be used for the new configuration ‘B2.tsm’ created in this way.Þ if series machine production is established, the scan should only be performed for informative purposes for comparison with a defined initial configuration. Changes are to be made with care!
If an EtherCAT device was created in the configuration (manually or through a scan), the I/O field can be scanned for devices/slaves.
Scan query after automatic creation of an EtherCAT device (left: TwinCAT 2; right: TwinCAT 3)
Manual triggering of a device scan on a specified EtherCAT device (left: TwinCAT 2; right: TwinCAT 3)
In the System Manager (TwinCAT 2) or the User Interface (TwinCAT 3) the scan process can be monitored via the progress bar at the bottom in the status bar.
Scan progressexemplary by TwinCAT 2
The configuration is established and can then be switched to online state (OPERATIONAL).
Config/FreeRun query (left: TwinCAT 2; right: TwinCAT 3)
In Config/FreeRun mode the System Manager display alternates between blue and red, and the EtherCAT device continues to operate with the idling cycle time of 4 ms (default setting), even without active task (NC, PLC).
Displaying of “Free Run” and “Config Mode” toggling right below in the status bar
TwinCAT can also be switched to this state by using a button (left: TwinCAT 2; right: TwinCAT 3)
The EtherCAT system should then be in a functional cyclic state, as shown in Fig. “Online display example”.
Online display example
Please note:
▪
all slaves should be in OP state
▪
the EtherCAT master should be in “Actual State” OP
▪
“frames/sec” should match the cycle time taking into account the sent number of frames
▪
no excessive “LostFrames” or CRC errors should occur
The configuration is now complete. It can be modified as described under manual procedure.
Troubleshooting
Various effects may occur during scanning.
▪
An unknown device is detected, i.e. an EtherCAT slave for which no ESI XML description is available.
In this case the System Manager offers to read any ESI that may be stored in the device. This case is described in the chapter "Notes regarding ESI device description".
▪
Device are not detected properly
Possible reasons include:
- faulty data links, resulting in data loss during the scan
- slave has invalid device description
The connections and devices should be checked in a targeted manner, e.g. via the emergency scan.
Then re-run the scan.
Faulty identification
In the System Manager such devices may be set up as EK0000 or unknown devices. Operation is not possible or meaningful.
Scan over existing Configuration
Note
Change of the configuration after comparison
With this scan (TwinCAT 2.11 or 3.1) only the device properties vendor (manufacturer), device name and revision are compared at present! A ‘ChangeTo’ or ‘Copy’ should only be carried out with care, taking into consideration the Beckhoff IO compatibility rule (see above). The device configuration is then replaced by the revision found; this can affect the supported process data and functions.
If a scan is initiated for an existing configuration, the actual I/O environment may match the configuration exactly or it may differ. This enables the configuration to be compared.
Identical configuration (left: TwinCAT 2; right: TwinCAT 3)
If differences are detected, they are shown in the correction dialog, so that the user can modify the configuration as required.
Correction dialog
It is advisable to tick the “Extended Information” check box to reveal differences in the revision.
Colour
Explanation
green
This EtherCAT slave matches the entry on the other side. Both type and revision match.
blue
This EtherCAT slave is present on the other side, but in a different revision. This other revision can have other default values for the process data as well as other/additional functions.
If the found revision is higher than the configured revision, the slave may be used provided compatibility issues are taken into account.
If the found revision is lower than the configured revision, it is likely that the slave cannot be used. The found device may not support all functions that the master expects based on the higher revision number.
light blue
This EtherCAT slave is ignored (“Ignore” button)
red
▪
This EtherCAT slave is not present on the other side.
▪
It is present, but in a different revision, which also differs in its properties from the one specified.
The compatibility principle then also applies here: if the found revision is higher than the configured revision, use is possible provided compatibility issues are taken into account, since the successor devices should support the functions of the predecessor devices.
If the found revision is lower than the configured revision, it is likely that the slave cannot be used. The found device may not support all functions that the master expects based on the higher revision number.
Device selection based on revision, compatibility
The ESI description also defines the process image, the communication type between master and slave/device and the device functions, if applicable. The physical device (firmware, if available) has to support the communication queries/settings of the master. This is backward compatible, i.e. newer devices (higher revision) should be supported if the EtherCAT master addresses them as an older revision. The following compatibility rule of thumb is to be assumed for Beckhoff EtherCAT Terminals/ Boxes/ EJ-modules:
device revision in the system >= device revision in the configuration
This also enables subsequent replacement of devices without changing the configuration (different specifications are possible for drives).
Example:
If an EL2521-0025-1018 is specified in the configuration, an EL2521-0025-1018 or higher (-1019, -1020) can be used in practice.
Name/revision of the terminal
If current ESI descriptions are available in the TwinCAT system, the last revision offered in the selection dialog matches the Beckhoff state of production. It is recommended to use the last device revision when creating a new configuration, if current Beckhoff devices are used in the real application. Older revisions should only be used if older devices from stock are to be used in the application.
In this case the process image of the device is shown in the configuration tree and can be parameterised as follows: linking with the task, CoE/DC settings, plug-in definition, startup settings, ...
Correction dialog with modifications
Once all modifications have been saved or accepted, click “OK” to transfer them to the real *.tsm configuration.
Change to Compatible Type
TwinCAT offers a function “Change to Compatible Type…” for the exchange of a device whilst retaining the links in the task.
Dialog “Change to Compatible Type…” (left: TwinCAT 2; right: TwinCAT 3)
This function is preferably to be used on AX5000 devices.
Change to Alternative Type
The TwinCAT System Manager offers a function for the exchange of a device: Change to Alternative Type
TwinCAT 2 Dialog Change to Alternative Type
If called, the System Manager searches in the procured device ESI (in this example: EL1202-0000) for details of compatible devices contained there. The configuration is changed and the ESI-EEPROM is overwritten at the same time – therefore this process is possible only in the online state (ConfigMode).


EtherCAT subscriber configuration

Commissioning [image] TwinCAT Development Environment [image] EtherCAT subscriber configuration
EtherCAT subscriber configuration
In the left-hand window of the TwinCAT 2 System Manager or the Solution Explorer of the TwinCAT 3 Development Environment respectively, click on the element of the terminal within the tree you wish to configure (in the example: EL3751 Terminal 3).
Branch element as terminal EL3751
In the right-hand window of the TwinCAT System manager (TwinCAT 2) or the Development Environment (TwinCAT 3), various tabs are now available for configuring the terminal. And yet the dimension of complexity of a subscriber determines which tabs are provided. Thus as illustrated in the example above the terminal EL3751 provides many setup options and also a respective number of tabs are available. On the contrary by the terminal EL1004 for example the tabs "General", "EtherCAT", "Process Data" and “Online“ are available only. Several terminals, as for instance the EL6695 provide special functions by a tab with its own terminal name, so “EL6695” in this case. A specific tab “Settings” by terminals with a wide range of setup options will be provided also (e.g. EL3751).
„General“ tab
“General” tab
Name | Name of the EtherCAT device
Id | Number of the EtherCAT device
Type | EtherCAT device type
Comment | Here you can add a comment (e.g. regarding the system).
Disabled | Here you can deactivate the EtherCAT device.
Create symbols | Access to this EtherCAT slave via ADS is only available if this control box is activated.
„EtherCAT“ tab
„EtherCAT“ tab
Type | EtherCAT device type
Product/Revision | Product and revision number of the EtherCAT device
Auto Inc Addr. | Auto increment address of the EtherCAT device. The auto increment address can be used for addressing each EtherCAT device in the communication ring through its physical position. Auto increment addressing is used during the start-up phase when the EtherCAT master allocates addresses to the EtherCAT devices. With auto increment addressing the first EtherCAT slave in the ring has the address 0000hex. For each further slave the address is decremented by 1 (FFFFhex, FFFEhex etc.).
EtherCAT Addr. | Fixed address of an EtherCAT slave. This address is allocated by the EtherCAT master during the start-up phase. Tick the control box to the left of the input field in order to modify the default value.
Previous Port | Name and port of the EtherCAT device to which this device is connected. If it is possible to connect this device with another one without changing the order of the EtherCAT devices in the communication ring, then this combination field is activated and the EtherCAT device to which this device is to be connected can be selected.
Advanced Settings | This button opens the dialogs for advanced settings.
The link at the bottom of the tab points to the product page for this EtherCAT device on the web.
“Process Data” tab
Indicates the configuration of the process data. The input and output data of the EtherCAT slave are represented as CANopen process data objects (Process Data Objects, PDOs). The user can select a PDO via PDO assignment and modify the content of the individual PDO via this dialog, if the EtherCAT slave supports this function.
“Process Data” tab
The process data (PDOs) transferred by an EtherCAT slave during each cycle are user data which the application expects to be updated cyclically or which are sent to the slave. To this end the EtherCAT master (Beckhoff TwinCAT) parameterizes each EtherCAT slave during the start-up phase to define which process data (size in bits/bytes, source location, transmission type) it wants to transfer to or from this slave. Incorrect configuration can prevent successful start-up of the slave.
For Beckhoff EtherCAT EL, ES, EM, EJ and EP slaves the following applies in general:
▪
The input/output process data supported by the device are defined by the manufacturer in the ESI/XML description. The TwinCAT EtherCAT Master uses the ESI description to configure the slave correctly.
▪
The process data can be modified in the system manager. See the device documentation.
Examples of modifications include: mask out a channel, displaying additional cyclic information, 16-bit display instead of 8-bit data size, etc.
▪
In so-called “intelligent” EtherCAT devices the process data information is also stored in the CoE directory. Any changes in the CoE directory that lead to different PDO settings prevent successful startup of the slave. It is not advisable to deviate from the designated process data, because the device firmware (if available) is adapted to these PDO combinations.
If the device documentation allows modification of process data, proceed as follows (see Figure “Configuring the process data”).
▪
A: select the device to configure
▪
B: in the “Process Data” tab select Input or Output under SyncManager (C)
▪
D: the PDOs can be selected or deselected
▪
H: the new process data are visible as linkable variables in the system manager
The new process data are active once the configuration has been activated and TwinCAT has been restarted (or the EtherCAT master has been restarted)
▪
E: if a slave supports this, Input and Output PDO can be modified simultaneously by selecting a so-called PDO record (“predefined PDO settings”).
Configuring the process data
Manual modification of the process data
According to the ESI description, a PDO can be identified as “fixed” with the flag “F” in the PDO overview (Fig. “Configuring the process data”, J). The configuration of such PDOs cannot be changed, even if TwinCAT offers the associated dialog (“Edit”). In particular, CoE content cannot be displayed as cyclic process data. This generally also applies in cases where a device supports download of the PDO configuration, “G”. In case of incorrect configuration the EtherCAT slave usually refuses to start and change to OP state. The System Manager displays an “invalid SM cfg” logger message: This error message (“invalid SM IN cfg” or “invalid SM OUT cfg”) also indicates the reason for the failed start.
A detailed description can be found at the end of this section.
„Startup“ tab
The Startup tab is displayed if the EtherCAT slave has a mailbox and supports the CANopen over EtherCAT (CoE) or Servo drive over EtherCAT protocol. This tab indicates which download requests are sent to the mailbox during startup. It is also possible to add new mailbox requests to the list display. The download requests are sent to the slave in the same order as they are shown in the list.
„Startup“ tab
Column
Description
Transition
Transition to which the request is sent. This can either be
▪
the transition from pre-operational to safe-operational (PS), or
▪
the transition from safe-operational to operational (SO).
If the transition is enclosed in "<>" (e.g. <PS>), the mailbox request is fixed and cannot be modified or deleted by the user.
Protocol
Type of mailbox protocol
Index
Index of the object
Data
Date on which this object is to be downloaded.
Comment
Description of the request to be sent to the mailbox
Move Up | This button moves the selected request up by one position in the list.
Move Down | This button moves the selected request down by one position in the list.
New | This button adds a new mailbox download request to be sent during startup.
Delete | This button deletes the selected entry.
Edit | This button edits an existing request.
“CoE – Online” tab
The additional CoE - Online tab is displayed if the EtherCAT slave supports the CANopen over EtherCAT (CoE) protocol. This dialog lists the content of the object list of the slave (SDO upload) and enables the user to modify the content of an object from this list. Details for the objects of the individual EtherCAT devices can be found in the device-specific object descriptions.
“CoE – Online” tab
Object list display
Column | Description
Index | Index and sub-index of the object
Name | Name of the object
Flags | RW | The object can be read, and data can be written to the object (read/write)
 | RO | The object can be read, but no data can be written to the object (read only)
 | P | An additional P identifies the object as a process data object.
Value | Value of the object
Update List | The Update list button updates all objects in the displayed list
Auto Update | If this check box is selected, the content of the objects is updated automatically.
Advanced | The Advanced button opens the Advanced Settings dialog. Here you can specify which objects are displayed in the list.
Dialog “Advanced settings”
Online - via SDO Information | If this option button is selected, the list of the objects included in the object list of the slave is uploaded from the slave via SDO information. The list below can be used to specify which object types are to be uploaded.
Offline - via EDS File | If this option button is selected, the list of the objects included in the object list is read from an EDS file provided by the user.
„Online“ tab
„Online“ tab
State Machine
Init | This button attempts to set the EtherCAT device to the Init state.
Pre-Op | This button attempts to set the EtherCAT device to the pre-operational state.
Op | This button attempts to set the EtherCAT device to the operational state.
Bootstrap | This button attempts to set the EtherCAT device to the Bootstrap state.
Safe-Op | This button attempts to set the EtherCAT device to the safe-operational state.
Clear Error | This button attempts to delete the fault display. If an EtherCAT slave fails during change of state it sets an error flag. Example: An EtherCAT slave is in PREOP state (pre-operational). The master now requests the SAFEOP state (safe-operational). If the slave fails during change of state it sets the error flag. The current state is now displayed as ERR PREOP. When the Clear Error button is pressed the error flag is cleared, and the current state is displayed as PREOP again.
Current State | Indicates the current state of the EtherCAT device.
Requested State | Indicates the state requested for the EtherCAT device.
DLL Status
Indicates the DLL status (data link layer status) of the individual ports of the EtherCAT slave. The DLL status can have four different states:
Status | Description
No Carrier / Open | No carrier signal is available at the port, but the port is open.
No Carrier / Closed | No carrier signal is available at the port, and the port is closed.
Carrier / Open | A carrier signal is available at the port, and the port is open.
Carrier / Closed | A carrier signal is available at the port, but the port is closed.
File Access over EtherCAT
Download | With this button a file can be written to the EtherCAT device.
Upload | With this button a file can be read from the EtherCAT device.
"DC" tab (Distributed Clocks)
"DC" tab (Distributed Clocks)
Operation Mode
Options (optional):
▪
FreeRun
▪
SM-Synchron
▪
DC-Synchron (Input based)
▪
DC-Synchron
Advanced Settings…
Advanced settings for readjustment of the real time determinant TwinCAT-clock
Detailed information to Distributed Clocks are specified on http://infosys.beckhoff.com:
Fieldbus Components → EtherCAT Terminals → EtherCAT System documentation → EtherCAT basics → Distributed Clocks
Additional information
•
Detailed description of Process Data tab


Detailed description of Process Data tab

Commissioning [image] TwinCAT Development Environment [image] EtherCAT subscriber configuration [image] Detailed description of Process Data tab
Detailed description of Process Data tab
Sync Manager
Lists the configuration of the Sync Manager (SM).
If the EtherCAT device has a mailbox, SM0 is used for the mailbox output (MbxOut) and SM1 for the mailbox input (MbxIn).
SM2 is used for the output process data (outputs) and SM3 (inputs) for the input process data.
If an input is selected, the corresponding PDO assignment is displayed in the PDO Assignment list below.
PDO Assignment
PDO assignment of the selected Sync Manager. All PDOs defined for this Sync Manager type are listed here:
▪
If the output Sync Manager (outputs) is selected in the Sync Manager list, all RxPDOs are displayed.
▪
If the input Sync Manager (inputs) is selected in the Sync Manager list, all TxPDOs are displayed.
The selected entries are the PDOs involved in the process data transfer. In the tree diagram of the System Manager these PDOs are displayed as variables of the EtherCAT device. The name of the variable is identical to the Name parameter of the PDO, as displayed in the PDO list. If an entry in the PDO assignment list is deactivated (not selected and greyed out), this indicates that the input is excluded from the PDO assignment. In order to be able to select a greyed out PDO, the currently selected PDO has to be deselected first.
Activation of PDO assignment
✓
If you have changed the PDO assignment, in order to activate the new PDO assignment,
1.
the EtherCAT slave has to run through the PS status transition cycle (from pre-operational to safe-operational) once (see Online tab),
2.
and the System Manager has to reload the EtherCAT slaves
( [image] button for TwinCAT 2 or [image] button for TwinCAT 3)
PDO list
List of all PDOs supported by this EtherCAT device. The content of the selected PDOs is displayed in the PDO Content list. The PDO configuration can be modified by double-clicking on an entry.
Column | Description
Index | PDO index.
Size | Size of the PDO in bytes.
Name | Name of the PDO. If this PDO is assigned to a Sync Manager, it appears as a variable of the slave with this parameter as the name.
Flags | F | Fixed content: The content of this PDO is fixed and cannot be changed by the System Manager.
 | M | Mandatory PDO. This PDO is mandatory and must therefore be assigned to a Sync Manager! Consequently, this PDO cannot be deleted from the PDO Assignment list
SM | Sync Manager to which this PDO is assigned. If this entry is empty, this PDO does not take part in the process data traffic.
SU | Sync unit to which this PDO is assigned.
PDO Content
Indicates the content of the PDO. If flag F (fixed content) of the PDO is not set the content can be modified.
Download
If the device is intelligent and has a mailbox, the configuration of the PDO and the PDO assignments can be downloaded to the device. This is an optional feature that is not supported by all EtherCAT slaves.
PDO Assignment
If this check box is selected, the PDO assignment that is configured in the PDO Assignment list is downloaded to the device on startup. The required commands to be sent to the device can be viewed in the Startup tab.
PDO Configuration
If this check box is selected, the configuration of the respective PDOs (as shown in the PDO list and the PDO Content display) is downloaded to the EtherCAT slave.


General notes for commissioning of the EtherCAT slave

Commissioning [image] General notes for commissioning of the EtherCAT slave
General notes for commissioning of the EtherCAT slave
This summary briefly deals with a number of aspects of EtherCAT Slave operation under TwinCAT. More detailed information on this may be found in the corresponding sections of, for instance, the EtherCAT System Documentation.
Diagnosis in real time: WorkingCounter, EtherCAT State and Status
Generally speaking an EtherCAT Slave provides a variety of diagnostic information that can be used by the controlling task.
This diagnostic information relates to differing levels of communication. It therefore has a variety of sources, and is also updated at various times.
Any application that relies on I/O data from a fieldbus being correct and up to date must make diagnostic access to the corresponding underlying layers. EtherCAT and the TwinCAT System Manager offer comprehensive diagnostic elements of this kind. Those diagnostic elements that are helpful to the controlling task for diagnosis that is accurate for the current cycle when in operation (not during commissioning) are discussed below.
Selection of the diagnostic information of an EtherCAT Slave
In general, an EtherCAT Slave offers
▪
communication diagnosis typical for a slave (diagnosis of successful participation in the exchange of process data, and correct operating mode)
This diagnosis is the same for all slaves.

as well as
▪
function diagnosis typical for a channel (device-dependent)
See the corresponding device documentation
The colors in Fig. “Selection of the diagnostic information of an EtherCAT Slave” also correspond to the variable colors in the System Manager, see Fig. “Basic EtherCAT Slave Diagnosis in the PLC”.
Colour | Meaning
yellow | Input variables from the Slave to the EtherCAT Master, updated in every cycle
red | Output variables from the Slave to the EtherCAT Master, updated in every cycle
green | Information variables for the EtherCAT Master that are updated acyclically. This means that it is possible that in any particular cycle they do not represent the latest possible status. It is therefore useful to read such variables through ADS.
Fig. “Basic EtherCAT Slave Diagnosis in the PLC” shows an example of an implementation of basic EtherCAT Slave Diagnosis. A Beckhoff EL3102 (2-channel analogue input terminal) is used here, as it offers both the communication diagnosis typical of a slave and the functional diagnosis that is specific to a channel. Structures are created as input variables in the PLC, each corresponding to the process image.
Basic EtherCAT Slave Diagnosis in the PLC
The following aspects are covered here:
Code
Function
Implementation
Application/evaluation
A
The EtherCAT Master's diagnostic information
updated acyclically (yellow) or provided acyclically (green).
At least the DevState is to be evaluated for the most recent cycle in the PLC.
The EtherCAT Master's diagnostic information offers many more possibilities than are treated in the EtherCAT System Documentation. A few keywords:
▪
CoE in the Master for communication with/through the Slaves
▪
Functions from TcEtherCAT.lib
▪
Perform an OnlineScan
B
In the example chosen (EL3102) the EL3102 comprises two analogue input channels that transmit a single function status for the most recent cycle.
Status
▪
the bit significations may be found in the device documentation
▪
other devices may supply more information, or none that is typical of a slave
In order for the higher-level PLC task (or corresponding control applications) to be able to rely on correct data, the function status must be evaluated there. Such information is therefore provided with the process data for the most recent cycle.
C
For every EtherCAT Slave that has cyclic process data, the Master displays, using what is known as a WorkingCounter, whether the slave is participating successfully and without error in the cyclic exchange of process data. This important, elementary information is therefore provided for the most recent cycle in the System Manager
1.
at the EtherCAT Slave, and, with identical contents
2.
as a collective variable at the EtherCAT Master (see Point A)
for linking.
WcState (Working Counter)
0: valid real-time communication in the last cycle
1: invalid real-time communication
This may possibly have effects on the process data of other Slaves that are located in the same SyncUnit
In order for the higher-level PLC task (or corresponding control applications) to be able to rely on correct data, the communication status of the EtherCAT Slave must be evaluated there. Such information is therefore provided with the process data for the most recent cycle.
D
Diagnostic information of the EtherCAT Master which, while it is represented at the slave for linking, is actually determined by the Master for the Slave concerned and represented there. This information cannot be characterized as real-time, because it
▪
is only rarely/never changed, except when the system starts up
▪
is itself determined acyclically (e.g. EtherCAT Status)
State
current Status (INIT..OP) of the Slave. The Slave must be in OP (=8) when operating normally.
AdsAddr
The ADS address is useful for communicating from the PLC/task via ADS with the EtherCAT Slave, e.g. for reading/writing to the CoE. The AMS-NetID of a slave corresponds to the AMS-NetID of the EtherCAT Master; communication with the individual Slave is possible via the port (= EtherCAT address).
Information variables for the EtherCAT Master that are updated acyclically. This means that it is possible that in any particular cycle they do not represent the latest possible status. It is therefore possible to read such variables through ADS.
Note
Diagnostic information
It is strongly recommended that the diagnostic information made available is evaluated so that the application can react accordingly.
CoE Parameter Directory
The CoE parameter directory (CanOpen-over-EtherCAT) is used to manage the set values for the slave concerned. Changes may, in some circumstances, have to be made here when commissioning a relatively complex EtherCAT Slave. It can be accessed through the TwinCAT System Manager, see Fig. “EL3102, CoE directory”:
EL3102, CoE directory
EtherCAT System Documentation
The comprehensive description in the EtherCAT System Documentation (EtherCAT Basics --> CoE Interface) must be observed!
A few brief extracts:
▪
Whether changes in the online directory are saved locally in the slave depends on the device. EL terminals (except the EL66xx) are able to save in this way.
▪
The user must manage the changes to the StartUp list.
Commissioning aid in the TwinCAT System Manager
Commissioning interfaces are being introduced as part of an ongoing process for EL/EP EtherCAT devices. These are available in TwinCAT System Managers from TwinCAT 2.11R2 and above. They are integrated into the System Manager through appropriately extended ESI configuration files.
Example of commissioning aid for a EL3204
This commissioning process simultaneously manages
▪
CoE Parameter Directory
▪
DC/FreeRun mode
▪
the available process data records (PDO)
Although the "Process Data", "DC", "Startup" and "CoE-Online" that used to be necessary for this are still displayed, it is recommended that, if the commissioning aid is used, the automatically generated settings are not changed by it.
The commissioning tool does not cover every possible application of an EL/EP device. If the available setting options are not adequate, the user can make the DC, PDO and CoE settings manually, as in the past.
EtherCAT State: automatic default behaviour of the TwinCAT System Manager and manual operation
After the operating power is switched on, an EtherCAT Slave must go through the following statuses
▪
INIT
▪
PREOP
▪
SAFEOP
▪
OP
to ensure sound operation. The EtherCAT Master directs these statuses in accordance with the initialization routines that are defined for commissioning the device by the ES/XML and user settings (Distributed Clocks (DC), PDO, CoE). See also the section on "Principles of Communication, EtherCAT State Machine" in this connection. Depending how much configuration has to be done, and on the overall communication, booting can take up to a few seconds.
The EtherCAT Master itself must go through these routines when starting, until it has reached at least the OP target state.
The target state wanted by the user, and which is brought about automatically at start-up by TwinCAT, can be set in the System Manager. As soon as TwinCAT reaches the status RUN, the TwinCAT EtherCAT Master will approach the target states.
Standard setting
The advanced settings of the EtherCAT Master are set as standard:
▪
EtherCAT Master: OP
▪
Slaves: OP
This setting applies equally to all Slaves.
Default behaviour of the System Manager
In addition, the target state of any particular Slave can be set in the "Advanced Settings" dialogue; the standard setting is again OP.
Default target state in the Slave
Manual Control
There are particular reasons why it may be appropriate to control the states from the application/task/PLC. For instance:
▪
for diagnostic reasons
▪
to induce a controlled restart of axes
▪
because a change in the times involved in starting is desirable
In that case it is appropriate in the PLC application to use the PLC function blocks from the TcEtherCAT.lib, which is available as standard, and to work through the states in a controlled manner using, for instance, FB_EcSetMasterState.
It is then useful to put the settings in the EtherCAT Master to INIT for master and slave.
PLC function blocks
Current consumption of the EJ modules from the E-bus
Each EtherCAT module requires a certain current from the E-bus (see technical data: “Current consumption E-bus”). The information about the current required from the E-bus supply is available for each module online and in the catalogue. The precalculated theoretical maximum E-bus current is displayed in the TwinCAT System Manager. A negative total amount in conjunction with an exclamation mark indicates that the value is too low.
System Manager current calculation
The E-bus system voltage is provided by Bus Couplers and power supply units (see section Power supply of the EtherCAT plug-in modules).


Appendix

Appendix
Appendix
Additional information
•
EtherCAT AL Status Codes
•
EJ9505 - Firmware compatibility
•
Support and Service


EtherCAT AL Status Codes

Appendix [image] EtherCAT AL Status Codes
EtherCAT AL Status Codes
For detailed information please refer to the EtherCAT system description.


EJ9505 - Firmware compatibility

Appendix [image] EJ9505 - Firmware compatibility
EJ9505 - Firmware compatibility
The EtherCAT plug-in module EJ9505 has no firmware.


Support and Service

Appendix [image] Support and Service
Support and Service
Beckhoff and their partners around the world offer comprehensive support and service, making available fast and competent assistance with all questions related to Beckhoff products and system solutions.
Beckhoff's branch offices and representatives
Please contact your Beckhoff branch office or representative for local support and service on Beckhoff products!
The addresses of Beckhoff's branch offices and representatives round the world can be found on her internet pages:
http://www.beckhoff.com
You will also find further documentation for Beckhoff components there.
Beckhoff Headquarters
Beckhoff Automation GmbH & Co. KG
Huelshorstweg 20
33415 Verl
Germany
Phone: | +49 5246 963 0
Fax: | +49 5246 963 198
e-mail: | info@beckhoff.com
Beckhoff Support
Support offers you comprehensive technical assistance, helping you not only with the application of individual Beckhoff products, but also with other, wide-ranging services:
▪
support
▪
design, programming and commissioning of complex automation systems
▪
and extensive training program for Beckhoff system components
Hotline: | +49 5246 963 157
Fax: | +49 5246 963 9157
e-mail: | support@beckhoff.com
Beckhoff Service
The Beckhoff Service Center supports you in all matters of after-sales service:
▪
on-site service
▪
repair service
▪
spare parts service
▪
hotline service
Hotline: | +49 5246 963 460
Fax: | +49 5246 963 479
e-mail: | service@beckhoff.com